/* A Bison parser, made by GNU Bison 3.7.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2020 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.7.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         parser_parse
#define yylex           parser_lex
#define yyerror         parser_error
#define yydebug         parser_debug
#define yynerrs         parser_nerrs

/* First part of user prologue.  */
#line 19 "dlls/vbscript/parser.y"


#include "vbscript.h"
#include "parse.h"

#include "wine/debug.h"

WINE_DEFAULT_DEBUG_CHANNEL(vbscript);

static int parser_error(unsigned*,parser_ctx_t*,const char*);

static void handle_isexpression_script(parser_ctx_t *ctx, expression_t *expr);

static void source_add_statement(parser_ctx_t*,statement_t*);
static void source_add_class(parser_ctx_t*,class_decl_t*);

static void *new_expression(parser_ctx_t*,expression_type_t,size_t);
static expression_t *new_bool_expression(parser_ctx_t*,VARIANT_BOOL);
static expression_t *new_string_expression(parser_ctx_t*,const WCHAR*);
static expression_t *new_long_expression(parser_ctx_t*,expression_type_t,LONG);
static expression_t *new_double_expression(parser_ctx_t*,double);
static expression_t *new_unary_expression(parser_ctx_t*,expression_type_t,expression_t*);
static expression_t *new_binary_expression(parser_ctx_t*,expression_type_t,expression_t*,expression_t*);
static expression_t *new_new_expression(parser_ctx_t*,const WCHAR*);

static member_expression_t *new_member_expression(parser_ctx_t*,expression_t*,const WCHAR*);
static call_expression_t *new_call_expression(parser_ctx_t*,expression_t*,expression_t*);
static call_expression_t *make_call_expression(parser_ctx_t*,expression_t*,expression_t*);

static void *new_statement(parser_ctx_t*,statement_type_t,size_t,unsigned);
static statement_t *new_call_statement(parser_ctx_t*,unsigned,BOOL,expression_t*);
static statement_t *new_assign_statement(parser_ctx_t*,unsigned,expression_t*,expression_t*);
static statement_t *new_set_statement(parser_ctx_t*,unsigned,expression_t*,expression_t*);
static statement_t *new_dim_statement(parser_ctx_t*,unsigned,dim_decl_t*);
static statement_t *new_redim_statement(parser_ctx_t*,unsigned,const WCHAR*,BOOL,expression_t*);
static statement_t *new_while_statement(parser_ctx_t*,unsigned,statement_type_t,expression_t*,statement_t*);
static statement_t *new_forto_statement(parser_ctx_t*,unsigned,const WCHAR*,expression_t*,expression_t*,expression_t*,statement_t*);
static statement_t *new_foreach_statement(parser_ctx_t*,unsigned,const WCHAR*,expression_t*,statement_t*);
static statement_t *new_if_statement(parser_ctx_t*,unsigned,expression_t*,statement_t*,elseif_decl_t*,statement_t*);
static statement_t *new_function_statement(parser_ctx_t*,unsigned,function_decl_t*);
static statement_t *new_onerror_statement(parser_ctx_t*,unsigned,BOOL);
static statement_t *new_const_statement(parser_ctx_t*,unsigned,const_decl_t*);
static statement_t *new_select_statement(parser_ctx_t*,unsigned,expression_t*,case_clausule_t*);
static statement_t *new_with_statement(parser_ctx_t*,unsigned,expression_t*,statement_t*);

static dim_decl_t *new_dim_decl(parser_ctx_t*,const WCHAR*,BOOL,dim_list_t*);
static dim_list_t *new_dim(parser_ctx_t*,unsigned,dim_list_t*);
static elseif_decl_t *new_elseif_decl(parser_ctx_t*,unsigned,expression_t*,statement_t*);
static function_decl_t *new_function_decl(parser_ctx_t*,const WCHAR*,function_type_t,unsigned,arg_decl_t*,statement_t*);
static arg_decl_t *new_argument_decl(parser_ctx_t*,const WCHAR*,BOOL);
static const_decl_t *new_const_decl(parser_ctx_t*,const WCHAR*,expression_t*);
static case_clausule_t *new_case_clausule(parser_ctx_t*,expression_t*,statement_t*,case_clausule_t*);

static class_decl_t *new_class_decl(parser_ctx_t*);
static class_decl_t *add_class_function(parser_ctx_t*,class_decl_t*,function_decl_t*);
static class_decl_t *add_dim_prop(parser_ctx_t*,class_decl_t*,dim_decl_t*,unsigned);

static statement_t *link_statements(statement_t*,statement_t*);

#define STORAGE_IS_PRIVATE    1
#define STORAGE_IS_DEFAULT    2

#define CHECK_ERROR if(((parser_ctx_t*)ctx)->hres != S_OK) YYABORT

#define YYLTYPE unsigned
#define YYLLOC_DEFAULT(Cur, Rhs, N) Cur = YYRHSLOC((Rhs), (N) ? 1 : 0)


#line 145 "dlls/vbscript/parser.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif


/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int parser_debug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    tEXPRESSION = 258,             /* tEXPRESSION  */
    tNL = 259,                     /* tNL  */
    tEMPTYBRACKETS = 260,          /* tEMPTYBRACKETS  */
    tEXPRLBRACKET = 261,           /* tEXPRLBRACKET  */
    tLTEQ = 262,                   /* tLTEQ  */
    tGTEQ = 263,                   /* tGTEQ  */
    tNEQ = 264,                    /* tNEQ  */
    tSTOP = 265,                   /* tSTOP  */
    tME = 266,                     /* tME  */
    tREM = 267,                    /* tREM  */
    tDOT = 268,                    /* tDOT  */
    tTRUE = 269,                   /* tTRUE  */
    tFALSE = 270,                  /* tFALSE  */
    tNOT = 271,                    /* tNOT  */
    tAND = 272,                    /* tAND  */
    tOR = 273,                     /* tOR  */
    tXOR = 274,                    /* tXOR  */
    tEQV = 275,                    /* tEQV  */
    tIMP = 276,                    /* tIMP  */
    tIS = 277,                     /* tIS  */
    tMOD = 278,                    /* tMOD  */
    tCALL = 279,                   /* tCALL  */
    tSUB = 280,                    /* tSUB  */
    tFUNCTION = 281,               /* tFUNCTION  */
    tGET = 282,                    /* tGET  */
    tLET = 283,                    /* tLET  */
    tCONST = 284,                  /* tCONST  */
    tDIM = 285,                    /* tDIM  */
    tREDIM = 286,                  /* tREDIM  */
    tPRESERVE = 287,               /* tPRESERVE  */
    tIF = 288,                     /* tIF  */
    tELSE = 289,                   /* tELSE  */
    tELSEIF = 290,                 /* tELSEIF  */
    tEND = 291,                    /* tEND  */
    tTHEN = 292,                   /* tTHEN  */
    tEXIT = 293,                   /* tEXIT  */
    tWHILE = 294,                  /* tWHILE  */
    tWEND = 295,                   /* tWEND  */
    tDO = 296,                     /* tDO  */
    tLOOP = 297,                   /* tLOOP  */
    tUNTIL = 298,                  /* tUNTIL  */
    tFOR = 299,                    /* tFOR  */
    tTO = 300,                     /* tTO  */
    tEACH = 301,                   /* tEACH  */
    tIN = 302,                     /* tIN  */
    tSELECT = 303,                 /* tSELECT  */
    tCASE = 304,                   /* tCASE  */
    tWITH = 305,                   /* tWITH  */
    tBYREF = 306,                  /* tBYREF  */
    tBYVAL = 307,                  /* tBYVAL  */
    tOPTION = 308,                 /* tOPTION  */
    tNOTHING = 309,                /* tNOTHING  */
    tEMPTY = 310,                  /* tEMPTY  */
    tNULL = 311,                   /* tNULL  */
    tCLASS = 312,                  /* tCLASS  */
    tSET = 313,                    /* tSET  */
    tNEW = 314,                    /* tNEW  */
    tPUBLIC = 315,                 /* tPUBLIC  */
    tPRIVATE = 316,                /* tPRIVATE  */
    tNEXT = 317,                   /* tNEXT  */
    tON = 318,                     /* tON  */
    tRESUME = 319,                 /* tRESUME  */
    tGOTO = 320,                   /* tGOTO  */
    tIdentifier = 321,             /* tIdentifier  */
    tString = 322,                 /* tString  */
    tDEFAULT = 323,                /* tDEFAULT  */
    tERROR = 324,                  /* tERROR  */
    tEXPLICIT = 325,               /* tEXPLICIT  */
    tPROPERTY = 326,               /* tPROPERTY  */
    tSTEP = 327,                   /* tSTEP  */
    tInt = 328,                    /* tInt  */
    tDouble = 329                  /* tDouble  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 93 "dlls/vbscript/parser.y"

    const WCHAR *string;
    statement_t *statement;
    expression_t *expression;
    member_expression_t *member;
    elseif_decl_t *elseif;
    dim_decl_t *dim_decl;
    dim_list_t *dim_list;
    function_decl_t *func_decl;
    arg_decl_t *arg_decl;
    class_decl_t *class_decl;
    const_decl_t *const_decl;
    case_clausule_t *case_clausule;
    unsigned uint;
    LONG integer;
    BOOL boolean;
    double dbl;

#line 285 "dlls/vbscript/parser.tab.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif



int parser_parse (parser_ctx_t *ctx);


/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_tEXPRESSION = 3,                /* tEXPRESSION  */
  YYSYMBOL_tNL = 4,                        /* tNL  */
  YYSYMBOL_tEMPTYBRACKETS = 5,             /* tEMPTYBRACKETS  */
  YYSYMBOL_tEXPRLBRACKET = 6,              /* tEXPRLBRACKET  */
  YYSYMBOL_tLTEQ = 7,                      /* tLTEQ  */
  YYSYMBOL_tGTEQ = 8,                      /* tGTEQ  */
  YYSYMBOL_tNEQ = 9,                       /* tNEQ  */
  YYSYMBOL_tSTOP = 10,                     /* tSTOP  */
  YYSYMBOL_tME = 11,                       /* tME  */
  YYSYMBOL_tREM = 12,                      /* tREM  */
  YYSYMBOL_tDOT = 13,                      /* tDOT  */
  YYSYMBOL_tTRUE = 14,                     /* tTRUE  */
  YYSYMBOL_tFALSE = 15,                    /* tFALSE  */
  YYSYMBOL_tNOT = 16,                      /* tNOT  */
  YYSYMBOL_tAND = 17,                      /* tAND  */
  YYSYMBOL_tOR = 18,                       /* tOR  */
  YYSYMBOL_tXOR = 19,                      /* tXOR  */
  YYSYMBOL_tEQV = 20,                      /* tEQV  */
  YYSYMBOL_tIMP = 21,                      /* tIMP  */
  YYSYMBOL_tIS = 22,                       /* tIS  */
  YYSYMBOL_tMOD = 23,                      /* tMOD  */
  YYSYMBOL_tCALL = 24,                     /* tCALL  */
  YYSYMBOL_tSUB = 25,                      /* tSUB  */
  YYSYMBOL_tFUNCTION = 26,                 /* tFUNCTION  */
  YYSYMBOL_tGET = 27,                      /* tGET  */
  YYSYMBOL_tLET = 28,                      /* tLET  */
  YYSYMBOL_tCONST = 29,                    /* tCONST  */
  YYSYMBOL_tDIM = 30,                      /* tDIM  */
  YYSYMBOL_tREDIM = 31,                    /* tREDIM  */
  YYSYMBOL_tPRESERVE = 32,                 /* tPRESERVE  */
  YYSYMBOL_tIF = 33,                       /* tIF  */
  YYSYMBOL_tELSE = 34,                     /* tELSE  */
  YYSYMBOL_tELSEIF = 35,                   /* tELSEIF  */
  YYSYMBOL_tEND = 36,                      /* tEND  */
  YYSYMBOL_tTHEN = 37,                     /* tTHEN  */
  YYSYMBOL_tEXIT = 38,                     /* tEXIT  */
  YYSYMBOL_tWHILE = 39,                    /* tWHILE  */
  YYSYMBOL_tWEND = 40,                     /* tWEND  */
  YYSYMBOL_tDO = 41,                       /* tDO  */
  YYSYMBOL_tLOOP = 42,                     /* tLOOP  */
  YYSYMBOL_tUNTIL = 43,                    /* tUNTIL  */
  YYSYMBOL_tFOR = 44,                      /* tFOR  */
  YYSYMBOL_tTO = 45,                       /* tTO  */
  YYSYMBOL_tEACH = 46,                     /* tEACH  */
  YYSYMBOL_tIN = 47,                       /* tIN  */
  YYSYMBOL_tSELECT = 48,                   /* tSELECT  */
  YYSYMBOL_tCASE = 49,                     /* tCASE  */
  YYSYMBOL_tWITH = 50,                     /* tWITH  */
  YYSYMBOL_tBYREF = 51,                    /* tBYREF  */
  YYSYMBOL_tBYVAL = 52,                    /* tBYVAL  */
  YYSYMBOL_tOPTION = 53,                   /* tOPTION  */
  YYSYMBOL_tNOTHING = 54,                  /* tNOTHING  */
  YYSYMBOL_tEMPTY = 55,                    /* tEMPTY  */
  YYSYMBOL_tNULL = 56,                     /* tNULL  */
  YYSYMBOL_tCLASS = 57,                    /* tCLASS  */
  YYSYMBOL_tSET = 58,                      /* tSET  */
  YYSYMBOL_tNEW = 59,                      /* tNEW  */
  YYSYMBOL_tPUBLIC = 60,                   /* tPUBLIC  */
  YYSYMBOL_tPRIVATE = 61,                  /* tPRIVATE  */
  YYSYMBOL_tNEXT = 62,                     /* tNEXT  */
  YYSYMBOL_tON = 63,                       /* tON  */
  YYSYMBOL_tRESUME = 64,                   /* tRESUME  */
  YYSYMBOL_tGOTO = 65,                     /* tGOTO  */
  YYSYMBOL_tIdentifier = 66,               /* tIdentifier  */
  YYSYMBOL_tString = 67,                   /* tString  */
  YYSYMBOL_tDEFAULT = 68,                  /* tDEFAULT  */
  YYSYMBOL_tERROR = 69,                    /* tERROR  */
  YYSYMBOL_tEXPLICIT = 70,                 /* tEXPLICIT  */
  YYSYMBOL_tPROPERTY = 71,                 /* tPROPERTY  */
  YYSYMBOL_tSTEP = 72,                     /* tSTEP  */
  YYSYMBOL_tInt = 73,                      /* tInt  */
  YYSYMBOL_tDouble = 74,                   /* tDouble  */
  YYSYMBOL_75_ = 75,                       /* ':'  */
  YYSYMBOL_76_ = 76,                       /* '='  */
  YYSYMBOL_77_ = 77,                       /* '('  */
  YYSYMBOL_78_ = 78,                       /* ')'  */
  YYSYMBOL_79_0_ = 79,                     /* '0'  */
  YYSYMBOL_80_ = 80,                       /* '.'  */
  YYSYMBOL_81_ = 81,                       /* ','  */
  YYSYMBOL_82_ = 82,                       /* '-'  */
  YYSYMBOL_83_ = 83,                       /* '>'  */
  YYSYMBOL_84_ = 84,                       /* '<'  */
  YYSYMBOL_85_ = 85,                       /* '&'  */
  YYSYMBOL_86_ = 86,                       /* '+'  */
  YYSYMBOL_87_ = 87,                       /* '\\'  */
  YYSYMBOL_88_ = 88,                       /* '*'  */
  YYSYMBOL_89_ = 89,                       /* '/'  */
  YYSYMBOL_90_ = 90,                       /* '^'  */
  YYSYMBOL_YYACCEPT = 91,                  /* $accept  */
  YYSYMBOL_Program = 92,                   /* Program  */
  YYSYMBOL_OptionExplicit_opt = 93,        /* OptionExplicit_opt  */
  YYSYMBOL_SourceElements = 94,            /* SourceElements  */
  YYSYMBOL_ExpressionNl_opt = 95,          /* ExpressionNl_opt  */
  YYSYMBOL_BodyStatements = 96,            /* BodyStatements  */
  YYSYMBOL_StatementsNl_opt = 97,          /* StatementsNl_opt  */
  YYSYMBOL_StatementsNl = 98,              /* StatementsNl  */
  YYSYMBOL_StatementNl = 99,               /* StatementNl  */
  YYSYMBOL_Statement = 100,                /* Statement  */
  YYSYMBOL_SimpleStatement = 101,          /* SimpleStatement  */
  YYSYMBOL_MemberExpression = 102,         /* MemberExpression  */
  YYSYMBOL_Preserve_opt = 103,             /* Preserve_opt  */
  YYSYMBOL_DimDeclList = 104,              /* DimDeclList  */
  YYSYMBOL_DimDecl = 105,                  /* DimDecl  */
  YYSYMBOL_DimList = 106,                  /* DimList  */
  YYSYMBOL_ConstDeclList = 107,            /* ConstDeclList  */
  YYSYMBOL_ConstDecl = 108,                /* ConstDecl  */
  YYSYMBOL_ConstExpression = 109,          /* ConstExpression  */
  YYSYMBOL_DoType = 110,                   /* DoType  */
  YYSYMBOL_Step_opt = 111,                 /* Step_opt  */
  YYSYMBOL_IfStatement = 112,              /* IfStatement  */
  YYSYMBOL_EndIf_opt = 113,                /* EndIf_opt  */
  YYSYMBOL_ElseIfs_opt = 114,              /* ElseIfs_opt  */
  YYSYMBOL_ElseIfs = 115,                  /* ElseIfs  */
  YYSYMBOL_ElseIf = 116,                   /* ElseIf  */
  YYSYMBOL_Else_opt = 117,                 /* Else_opt  */
  YYSYMBOL_CaseClausules = 118,            /* CaseClausules  */
  YYSYMBOL_Arguments = 119,                /* Arguments  */
  YYSYMBOL_ArgumentList_opt = 120,         /* ArgumentList_opt  */
  YYSYMBOL_ArgumentList = 121,             /* ArgumentList  */
  YYSYMBOL_EmptyBrackets_opt = 122,        /* EmptyBrackets_opt  */
  YYSYMBOL_ExpressionList = 123,           /* ExpressionList  */
  YYSYMBOL_Expression = 124,               /* Expression  */
  YYSYMBOL_EqvExpression = 125,            /* EqvExpression  */
  YYSYMBOL_XorExpression = 126,            /* XorExpression  */
  YYSYMBOL_OrExpression = 127,             /* OrExpression  */
  YYSYMBOL_AndExpression = 128,            /* AndExpression  */
  YYSYMBOL_NotExpression = 129,            /* NotExpression  */
  YYSYMBOL_EqualityExpression = 130,       /* EqualityExpression  */
  YYSYMBOL_ConcatExpression = 131,         /* ConcatExpression  */
  YYSYMBOL_AdditiveExpression = 132,       /* AdditiveExpression  */
  YYSYMBOL_ModExpression = 133,            /* ModExpression  */
  YYSYMBOL_IntdivExpression = 134,         /* IntdivExpression  */
  YYSYMBOL_MultiplicativeExpression = 135, /* MultiplicativeExpression  */
  YYSYMBOL_ExpExpression = 136,            /* ExpExpression  */
  YYSYMBOL_SignExpression = 137,           /* SignExpression  */
  YYSYMBOL_UnaryExpression = 138,          /* UnaryExpression  */
  YYSYMBOL_CallExpression = 139,           /* CallExpression  */
  YYSYMBOL_LiteralExpression = 140,        /* LiteralExpression  */
  YYSYMBOL_NumericLiteralExpression = 141, /* NumericLiteralExpression  */
  YYSYMBOL_IntegerValue = 142,             /* IntegerValue  */
  YYSYMBOL_PrimaryExpression = 143,        /* PrimaryExpression  */
  YYSYMBOL_ClassDeclaration = 144,         /* ClassDeclaration  */
  YYSYMBOL_ClassBody = 145,                /* ClassBody  */
  YYSYMBOL_PropertyDecl = 146,             /* PropertyDecl  */
  YYSYMBOL_FunctionDecl = 147,             /* FunctionDecl  */
  YYSYMBOL_Storage_opt = 148,              /* Storage_opt  */
  YYSYMBOL_Storage = 149,                  /* Storage  */
  YYSYMBOL_ArgumentsDecl_opt = 150,        /* ArgumentsDecl_opt  */
  YYSYMBOL_ArgumentDeclList = 151,         /* ArgumentDeclList  */
  YYSYMBOL_ArgumentDecl = 152,             /* ArgumentDecl  */
  YYSYMBOL_Identifier = 153,               /* Identifier  */
  YYSYMBOL_StSep = 154                     /* StSep  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  50
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1346

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  91
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  64
/* YYNRULES -- Number of rules.  */
#define YYNRULES  189
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  363

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   329


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    85,     2,
      77,    78,    88,    86,    81,    82,    80,    89,    79,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    75,     2,
      84,    76,    83,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,    87,     2,    90,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   155,   155,   156,   159,   160,   163,   164,   165,   168,
     169,   172,   173,   174,   177,   178,   181,   182,   185,   188,
     189,   190,   191,   192,   195,   197,   198,   200,   201,   203,
     204,   206,   209,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   226,   228,   230,   234,
     235,   236,   240,   241,   244,   245,   248,   249,   250,   253,
     254,   257,   258,   261,   264,   265,   268,   269,   272,   273,
     276,   278,   279,   283,   284,   287,   288,   291,   292,   295,
     299,   300,   303,   304,   305,   309,   310,   313,   314,   317,
     318,   319,   322,   323,   326,   327,   330,   331,   334,   335,
     338,   339,   342,   343,   346,   347,   350,   351,   354,   355,
     356,   357,   358,   359,   360,   361,   364,   365,   368,   369,
     370,   373,   374,   377,   378,   382,   383,   385,   389,   390,
     393,   394,   395,   398,   399,   400,   403,   404,   405,   409,
     410,   411,   412,   413,   414,   415,   418,   419,   420,   423,
     424,   427,   428,   431,   434,   435,   436,   438,   440,   442,
     443,   444,   445,   448,   450,   452,   456,   458,   462,   463,
     466,   467,   468,   471,   472,   475,   476,   479,   480,   481,
     485,   486,   487,   488,   489,   490,   494,   495,   496,   497
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "tEXPRESSION", "tNL",
  "tEMPTYBRACKETS", "tEXPRLBRACKET", "tLTEQ", "tGTEQ", "tNEQ", "tSTOP",
  "tME", "tREM", "tDOT", "tTRUE", "tFALSE", "tNOT", "tAND", "tOR", "tXOR",
  "tEQV", "tIMP", "tIS", "tMOD", "tCALL", "tSUB", "tFUNCTION", "tGET",
  "tLET", "tCONST", "tDIM", "tREDIM", "tPRESERVE", "tIF", "tELSE",
  "tELSEIF", "tEND", "tTHEN", "tEXIT", "tWHILE", "tWEND", "tDO", "tLOOP",
  "tUNTIL", "tFOR", "tTO", "tEACH", "tIN", "tSELECT", "tCASE", "tWITH",
  "tBYREF", "tBYVAL", "tOPTION", "tNOTHING", "tEMPTY", "tNULL", "tCLASS",
  "tSET", "tNEW", "tPUBLIC", "tPRIVATE", "tNEXT", "tON", "tRESUME",
  "tGOTO", "tIdentifier", "tString", "tDEFAULT", "tERROR", "tEXPLICIT",
  "tPROPERTY", "tSTEP", "tInt", "tDouble", "':'", "'='", "'('", "')'",
  "'0'", "'.'", "','", "'-'", "'>'", "'<'", "'&'", "'+'", "'\\\\'", "'*'",
  "'/'", "'^'", "$accept", "Program", "OptionExplicit_opt",
  "SourceElements", "ExpressionNl_opt", "BodyStatements",
  "StatementsNl_opt", "StatementsNl", "StatementNl", "Statement",
  "SimpleStatement", "MemberExpression", "Preserve_opt", "DimDeclList",
  "DimDecl", "DimList", "ConstDeclList", "ConstDecl", "ConstExpression",
  "DoType", "Step_opt", "IfStatement", "EndIf_opt", "ElseIfs_opt",
  "ElseIfs", "ElseIf", "Else_opt", "CaseClausules", "Arguments",
  "ArgumentList_opt", "ArgumentList", "EmptyBrackets_opt",
  "ExpressionList", "Expression", "EqvExpression", "XorExpression",
  "OrExpression", "AndExpression", "NotExpression", "EqualityExpression",
  "ConcatExpression", "AdditiveExpression", "ModExpression",
  "IntdivExpression", "MultiplicativeExpression", "ExpExpression",
  "SignExpression", "UnaryExpression", "CallExpression",
  "LiteralExpression", "NumericLiteralExpression", "IntegerValue",
  "PrimaryExpression", "ClassDeclaration", "ClassBody", "PropertyDecl",
  "FunctionDecl", "Storage_opt", "Storage", "ArgumentsDecl_opt",
  "ArgumentDeclList", "ArgumentDecl", "Identifier", "StSep", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,    58,    61,    40,    41,    48,
      46,    44,    45,    62,    60,    38,    43,    92,    42,    47,
      94
};
#endif

#define YYPACT_NINF (-259)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-169)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      59,   529,   -42,    42,  -259,   529,  -259,   -12,  -259,  -259,
     529,  -259,  -259,  -259,   300,  -259,  -259,  -259,  -259,  -259,
    -259,  -259,  -259,  -259,  -259,   550,   550,  -259,  -259,    17,
      41,    47,    87,    99,  -259,    25,    40,   -29,   108,    52,
      55,    68,  -259,  -259,    30,  -259,  -259,  -259,  -259,    39,
    -259,   627,    -6,  -259,  -259,  -259,  -259,  -259,  -259,   529,
     529,   529,   529,   529,   550,   550,   550,   550,   550,   550,
     550,   550,   550,   550,   550,   550,   550,   550,   550,  -259,
     426,   100,  -259,    39,    39,  -259,  -259,   667,   300,   300,
     139,   529,    93,   529,    60,   204,   128,   529,   300,   170,
     112,  -259,   113,   805,  -259,   182,   117,  -259,   349,  -259,
    -259,   129,  -259,  -259,    41,    47,    87,    99,  -259,    40,
      40,    40,    40,    40,    40,    40,   -29,   108,   108,    52,
      55,    68,    68,  -259,   426,   116,    -8,  -259,  -259,  -259,
    -259,  -259,   120,   122,  -259,   121,     5,  -259,   138,     3,
    -259,  -259,  -259,  -259,  -259,     8,  -259,  -259,   529,  1073,
     300,   137,   529,     8,    39,    13,  -259,    92,  -259,  -259,
     805,   529,  -259,  -259,   300,   300,  -259,  -259,   426,   300,
     133,   300,  -259,   -27,   134,   738,  1140,     8,   163,  -259,
      39,   169,   529,     8,  1207,    91,   529,   155,   140,  -259,
     197,    14,    14,  -259,  -259,   135,  -259,  -259,  -259,  -259,
    -259,   146,   144,   426,  1006,    88,   188,  1073,    97,  1006,
     529,    24,   180,   194,   300,   195,    39,    39,   103,   166,
     197,  -259,  -259,  -259,   273,  -259,    39,    39,  -259,  -259,
     -27,   157,   198,   939,   210,  -259,  -259,   202,   529,  -259,
       8,   529,   455,   201,   196,    39,   200,    91,    91,    21,
      39,   300,   300,   167,   173,   246,   872,   872,  -259,  -259,
     529,   224,  -259,   198,   225,  -259,  -259,   197,  1274,    16,
      39,    39,    -1,   212,  -259,    91,    39,  -259,  -259,   203,
     211,   213,    91,   246,   246,  -259,   273,  -259,   226,   872,
     182,   227,    23,   264,   242,  -259,  -259,   218,   529,    39,
    1207,  1006,   529,  -259,  -259,  -259,    14,   207,   208,  -259,
    -259,  -259,  -259,   256,  -259,   260,   285,  1207,   257,  -259,
     197,  1274,  -259,   180,  -259,    39,   273,   273,  -259,  -259,
    1006,  -259,  -259,   230,  -259,   872,   215,   217,  -259,  -259,
     261,    39,    39,   228,   872,   872,  -259,   262,   266,   229,
     232,  -259,  -259
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       4,     9,     0,     0,     6,     0,   152,     0,   139,   140,
       0,   145,   143,   144,     0,   180,   141,   181,   182,   183,
     184,   185,   147,   148,   146,     0,     0,     3,   137,     0,
      96,    98,   100,   102,   104,   106,   108,   116,   118,   121,
     123,   125,   128,   130,   134,   133,   142,   136,    49,     0,
       1,   168,     0,    51,   107,   135,   131,   132,    10,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    85,
       0,     0,   138,   186,   187,     5,    41,     0,     0,     0,
      52,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     171,   172,     0,    19,     7,     0,    21,    29,    87,     8,
      34,     0,   169,   151,    97,    99,   101,   103,   105,   114,
     113,   110,   115,   109,   111,   112,   117,   120,   119,   122,
     124,   126,   127,   129,     0,     0,    89,    50,   188,   189,
      25,    44,    61,     0,    27,    54,    56,    53,     0,     0,
      39,    37,    35,    36,    38,     0,    66,    67,     0,   168,
       0,     0,     0,     0,     0,     0,   170,     0,    20,    18,
      23,     0,    24,    88,     0,     0,    91,    86,     0,     0,
       0,     0,    58,     0,     0,   168,   168,     0,     0,    15,
       0,     0,     0,     0,   168,   168,     0,     0,     0,    22,
      26,    92,    92,    90,    62,     0,    63,    64,    55,   150,
     149,     0,    59,     0,    14,    73,     0,   168,    33,    16,
       0,     0,    82,     0,     0,     0,   161,   155,     0,   169,
      40,    42,    43,    93,     0,   173,     0,     0,    65,    57,
       0,     0,    75,   168,     0,    71,    30,     0,     0,    17,
       0,     0,     0,     0,     0,   159,     0,   168,   168,     0,
     157,     0,     0,     0,   175,    92,   168,   168,    60,    28,
       0,    80,    76,    77,    73,    74,    31,    32,   168,    68,
       0,     0,    94,     0,    48,   168,     0,   162,   156,     0,
       0,     0,   168,    92,    92,   174,     0,   177,     0,   168,
      12,     0,     0,     0,     0,    78,    72,     0,     0,     0,
     168,    14,     0,    47,   160,   153,    92,     0,     0,   158,
     178,   179,   176,     0,    13,     0,     0,   168,     0,    46,
      69,   168,    83,    82,    95,     0,     0,     0,   166,   167,
      14,    81,    70,     0,    84,   168,     0,     0,    79,    45,
       0,     0,     0,     0,   168,   168,   163,     0,     0,     0,
       0,   164,   165
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -259,  -259,  -259,  -259,  -259,  -258,  -178,    85,   255,   -47,
     -40,  -259,  -259,   126,    84,    72,   141,  -259,  -259,    98,
    -259,  -259,    43,  -259,    45,  -259,  -259,    -7,  -259,  -259,
    -107,  -243,     9,     1,   277,   259,   279,   284,     7,  -259,
     265,   276,    96,   274,   275,   102,     0,   270,   -44,   172,
     148,  -259,  -259,  -259,  -227,  -259,  -190,  -181,  -172,  -199,
      53,  -146,   -14,   101
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     3,     4,    51,    27,   298,   188,   189,   299,   300,
     190,    28,   148,   144,   145,   211,   141,   142,   206,   158,
     309,   107,   245,   271,   272,   273,   304,   253,    82,   172,
     135,   235,   281,   136,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,   212,    47,   109,   225,   226,   110,   111,   112,   236,
     263,   264,    48,    85
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      55,   173,    29,   237,   105,   227,    52,   108,   216,   301,
     182,   106,    83,    59,   228,    59,   223,    54,    79,   233,
      59,    58,   297,   229,    59,    56,    57,   176,    49,    59,
     287,   288,    64,    65,    66,    79,   242,    59,    59,   247,
     185,   324,    50,    83,    59,    59,   209,    67,   289,   290,
     320,   321,   210,    72,    53,   165,   168,    73,   314,   108,
     326,    60,     1,   106,    83,   319,    61,   227,   227,   251,
     118,   203,   113,   178,   143,   146,   228,   228,   133,   291,
     312,   161,   183,    84,   164,   229,   229,   350,   308,   196,
      80,   234,   149,    81,   155,   227,   357,   358,   163,   156,
     307,    68,   227,   157,   228,    62,   241,    80,    69,    70,
      81,   228,     2,   229,    84,   108,    63,   335,   150,   151,
     229,   224,   243,   199,   244,    71,   108,  -154,   174,   175,
     106,    74,   332,   333,   152,    84,   156,   153,   215,    75,
     157,   108,   108,    76,    77,   106,   191,     8,     9,   341,
     108,   100,   101,   343,   174,   175,   197,   198,    78,   187,
     201,   202,   348,   193,   154,   143,   137,   146,   127,   128,
     108,   147,   200,   108,   259,   108,     5,   162,   131,   132,
     166,     6,   167,     7,   138,   139,   169,    11,    12,    13,
     346,   347,   170,   221,   177,   159,   274,   230,   180,   108,
      16,   179,   181,   106,   184,   218,    22,    23,    22,    23,
     146,   213,    24,   192,    24,   205,   220,   231,    59,   232,
     265,   250,   108,   108,   239,   240,   106,   106,   246,   252,
     254,   256,   260,   270,   108,   269,    15,   283,    17,    18,
      19,    20,    21,   275,   276,   295,   284,   293,   294,   277,
     160,   233,   279,   282,   296,   108,   186,   286,   303,   106,
     313,   244,   323,   325,   194,   195,   108,   108,   327,   316,
      15,   302,    17,    18,    19,    20,    21,   317,   328,   318,
     329,   338,   265,   108,   336,   337,   339,   108,   217,   340,
     342,   219,   349,   351,   222,   352,   108,   353,   359,   356,
     361,   108,   360,   362,   249,   106,   104,   208,   255,   330,
     108,   108,   268,   282,   106,   106,   248,   306,   305,   115,
     204,   334,   265,   265,   261,   262,   344,   257,   258,   119,
     120,   121,   122,   123,   124,   125,   114,   266,   267,    15,
     116,    17,    18,    19,    20,    21,   117,   126,   129,   322,
     130,   278,   207,   238,    79,     5,   285,   140,     0,     0,
       6,   292,     7,     8,     9,    10,    15,     0,    17,    18,
      19,    20,    21,     0,     0,     0,     0,     0,     0,     0,
       0,   310,   311,     0,     0,     0,     0,   315,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    11,    12,    13,     0,     0,    14,     0,
     331,     0,     0,     0,     0,    15,    16,    17,    18,    19,
      20,    21,    22,    23,     0,   171,    80,     0,    24,    81,
     134,    25,     5,     0,     0,    26,   345,     6,     0,     7,
       8,     9,    10,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   354,   355,     0,     0,     0,     0,     0,     0,
       0,     5,     0,     0,     0,     0,     6,     0,     7,     8,
       9,    10,     0,     0,     0,     0,     0,     0,     0,     0,
      11,    12,    13,     0,     0,    14,     0,     0,     0,   280,
       0,     0,    15,    16,    17,    18,    19,    20,    21,    22,
      23,     0,     0,     0,     0,    24,     0,   134,    25,    11,
      12,    13,    26,     0,    14,     0,     0,     0,     0,     0,
       0,    15,    16,    17,    18,    19,    20,    21,    22,    23,
       0,     0,     0,     0,    24,     5,     0,    25,     0,     0,
       6,    26,     7,     8,     9,    10,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     5,     0,     0,     0,
       0,     6,     0,     7,     8,     9,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    11,    12,    13,     0,     0,    14,     0,
       0,     0,     0,     0,     0,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    11,    12,    13,     0,    24,    14,
       0,    25,     0,     0,     0,    26,    15,    16,    17,    18,
      19,    20,    21,    22,    23,     0,     0,    -2,     0,    24,
       0,     0,    25,     5,     0,     0,    26,    86,     6,     0,
       7,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    87,     0,     0,     0,     0,    88,    89,    90,     0,
      91,     0,     0,     0,     0,    92,    93,     0,    94,     0,
       0,    95,     0,     5,     0,    96,     0,    97,     6,     0,
       7,     8,     9,     0,    98,    99,     0,   100,   101,     0,
     102,     0,     0,    15,     0,    17,    18,    19,    20,    21,
       0,     0,   103,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    11,    12,    13,     0,     0,    14,     0,     0,     0,
       0,     0,     0,    15,    16,    17,    18,    19,    20,    21,
      22,    23,   214,     0,     5,     0,    24,     0,    86,     6,
       0,     7,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    87,     0,     0,     0,     0,    88,    89,    90,
       0,    91,     0,     0,     0,     0,    92,    93,     0,    94,
       0,     0,    95,     0,     0,     0,    96,     0,    97,     0,
       0,     0,     0,     0,     0,     0,    99,     0,   100,   101,
       0,   102,     0,     0,    15,     0,    17,    18,    19,    20,
      21,     5,     0,   103,     0,    86,     6,     0,     7,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    87,
    -168,  -168,     0,     0,    88,    89,    90,     0,    91,     0,
       0,     0,     0,    92,    93,     0,    94,     0,     0,    95,
       0,     0,     0,    96,     0,    97,     0,     0,     0,     0,
       0,     0,     0,    99,     0,   100,   101,     0,   102,     0,
       0,    15,     0,    17,    18,    19,    20,    21,     5,     0,
     103,     0,    86,     6,     0,     7,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    87,     0,     0,     0,
       0,    88,    89,    90,     0,    91,     0,     0,   -11,     0,
      92,    93,     0,    94,     0,     0,    95,     0,     0,     0,
      96,     0,    97,     0,     0,     0,     0,     0,     0,     0,
      99,     0,   100,   101,     0,   102,     0,     0,    15,     0,
      17,    18,    19,    20,    21,     5,     0,   103,     0,    86,
       6,     0,     7,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    87,     0,     0,     0,     0,    88,    89,
      90,     0,    91,     0,     0,     0,     0,    92,    93,     0,
      94,     0,     0,    95,     0,     0,     0,    96,     0,    97,
       0,     0,     0,     0,     0,     0,     0,    99,     0,   100,
     101,     0,   102,     0,     0,    15,     0,    17,    18,    19,
      20,    21,     5,     0,   103,     0,    86,     6,     0,     7,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      87,  -168,  -168,     0,     0,    88,    89,    90,     0,    91,
       0,     0,     0,     0,    92,    93,     0,    94,     0,     0,
      95,     0,     0,     0,    96,     0,    97,     0,     0,     0,
       0,     0,     0,     0,    99,     0,   100,   101,     0,   102,
       0,     0,    15,     0,    17,    18,    19,    20,    21,     5,
       0,     0,     0,    86,     6,     0,     7,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    87,     0,     0,
       0,     0,    88,    89,    90,     0,    91,     0,     0,     0,
       0,    92,    93,     0,    94,   -14,     0,    95,     0,     0,
       0,    96,     0,    97,     0,     0,     0,     0,     0,     0,
       0,    99,     0,   100,   101,     0,   102,     0,     0,    15,
       0,    17,    18,    19,    20,    21,     5,     0,     0,     0,
      86,     6,     0,     7,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    87,     0,     0,     0,     0,    88,
      89,    90,     0,    91,     0,     0,     0,     0,    92,    93,
     -14,    94,     0,     0,    95,     0,     0,     0,    96,     0,
      97,     0,     0,     0,     0,     0,     0,     0,    99,     0,
     100,   101,     0,   102,     0,     0,    15,     0,    17,    18,
      19,    20,    21,     5,     0,     0,     0,    86,     6,     0,
       7,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    87,     0,     0,     0,     0,    88,    89,    90,     0,
      91,     0,     0,   -14,     0,    92,    93,     0,    94,     0,
       0,    95,     0,     0,     0,    96,     0,    97,     0,     0,
       0,     0,     0,     0,     0,    99,     0,   100,   101,     0,
     102,     0,     0,    15,     0,    17,    18,    19,    20,    21,
       5,     0,     0,     0,    86,     6,     0,     7,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    87,     0,
       0,     0,     0,    88,    89,    90,     0,    91,     0,     0,
       0,     0,    92,    93,     0,    94,     0,     0,    95,     0,
       0,     0,    96,     0,    97,     0,     0,     0,     0,     0,
       0,     0,    99,     0,   100,   101,   -14,   102,     0,     0,
      15,     0,    17,    18,    19,    20,    21
};

static const yytype_int16 yycheck[] =
{
      14,   108,     1,   202,    51,   195,     5,    51,   186,   267,
       5,    51,     4,    21,   195,    21,   194,    10,     5,     5,
      21,     4,   265,   195,    21,    25,    26,   134,    70,    21,
     257,   258,     7,     8,     9,     5,   214,    21,    21,   217,
      37,   299,     0,     4,    21,    21,    73,    22,    27,    28,
     293,   294,    79,    82,    66,    99,   103,    86,   285,   103,
      37,    20,     3,   103,     4,   292,    19,   257,   258,    45,
      63,   178,    78,    81,    88,    89,   257,   258,    78,    58,
      81,    95,    77,    75,    98,   257,   258,   345,    72,    76,
      77,    77,    91,    80,    93,   285,   354,   355,    97,    39,
     278,    76,   292,    43,   285,    18,   213,    77,    83,    84,
      80,   292,    53,   285,    75,   159,    17,   316,    25,    26,
     292,    30,    34,   170,    36,    85,   170,    36,    25,    26,
     170,    23,   310,   311,    41,    75,    39,    44,   185,    87,
      43,   185,   186,    88,    89,   185,   160,    14,    15,   327,
     194,    60,    61,   331,    25,    26,    64,    65,    90,   158,
     174,   175,   340,   162,    71,   179,    66,   181,    72,    73,
     214,    32,   171,   217,    71,   219,     6,    49,    76,    77,
      68,    11,    69,    13,    83,    84,     4,    54,    55,    56,
     336,   337,    75,   192,    78,    94,   243,   196,    76,   243,
      67,    81,    81,   243,    66,    42,    73,    74,    73,    74,
     224,    77,    79,    76,    79,    82,    47,    62,    21,    79,
     234,   220,   266,   267,    78,    81,   266,   267,    40,    49,
      36,    36,    66,    35,   278,    78,    66,    36,    68,    69,
      70,    71,    72,    33,    42,    78,    50,   261,   262,   248,
      46,     5,   251,   252,    81,   299,   155,    57,    34,   299,
      48,    36,    36,    36,   163,   164,   310,   311,     4,    66,
      66,   270,    68,    69,    70,    71,    72,    66,    36,    66,
      62,    25,   296,   327,    77,    77,    26,   331,   187,     4,
      33,   190,    62,    78,   193,    78,   340,    36,    36,    71,
      71,   345,    36,    71,   219,   345,    51,   181,   224,   308,
     354,   355,   240,   312,   354,   355,   218,   274,   273,    60,
     179,   312,   336,   337,    51,    52,   333,   226,   227,    64,
      65,    66,    67,    68,    69,    70,    59,   236,   237,    66,
      61,    68,    69,    70,    71,    72,    62,    71,    74,   296,
      75,   250,   180,   205,     5,     6,   255,    87,    -1,    -1,
      11,   260,    13,    14,    15,    16,    66,    -1,    68,    69,
      70,    71,    72,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   280,   281,    -1,    -1,    -1,    -1,   286,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    54,    55,    56,    -1,    -1,    59,    -1,
     309,    -1,    -1,    -1,    -1,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    -1,    76,    77,    -1,    79,    80,
      81,    82,     6,    -1,    -1,    86,   335,    11,    -1,    13,
      14,    15,    16,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   351,   352,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     6,    -1,    -1,    -1,    -1,    11,    -1,    13,    14,
      15,    16,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      54,    55,    56,    -1,    -1,    59,    -1,    -1,    -1,    34,
      -1,    -1,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    -1,    -1,    -1,    -1,    79,    -1,    81,    82,    54,
      55,    56,    86,    -1,    59,    -1,    -1,    -1,    -1,    -1,
      -1,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      -1,    -1,    -1,    -1,    79,     6,    -1,    82,    -1,    -1,
      11,    86,    13,    14,    15,    16,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     6,    -1,    -1,    -1,
      -1,    11,    -1,    13,    14,    15,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    54,    55,    56,    -1,    -1,    59,    -1,
      -1,    -1,    -1,    -1,    -1,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    54,    55,    56,    -1,    79,    59,
      -1,    82,    -1,    -1,    -1,    86,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    -1,    -1,     0,    -1,    79,
      -1,    -1,    82,     6,    -1,    -1,    86,    10,    11,    -1,
      13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    24,    -1,    -1,    -1,    -1,    29,    30,    31,    -1,
      33,    -1,    -1,    -1,    -1,    38,    39,    -1,    41,    -1,
      -1,    44,    -1,     6,    -1,    48,    -1,    50,    11,    -1,
      13,    14,    15,    -1,    57,    58,    -1,    60,    61,    -1,
      63,    -1,    -1,    66,    -1,    68,    69,    70,    71,    72,
      -1,    -1,    75,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    54,    55,    56,    -1,    -1,    59,    -1,    -1,    -1,
      -1,    -1,    -1,    66,    67,    68,    69,    70,    71,    72,
      73,    74,     4,    -1,     6,    -1,    79,    -1,    10,    11,
      -1,    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    24,    -1,    -1,    -1,    -1,    29,    30,    31,
      -1,    33,    -1,    -1,    -1,    -1,    38,    39,    -1,    41,
      -1,    -1,    44,    -1,    -1,    -1,    48,    -1,    50,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    58,    -1,    60,    61,
      -1,    63,    -1,    -1,    66,    -1,    68,    69,    70,    71,
      72,     6,    -1,    75,    -1,    10,    11,    -1,    13,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    24,
      25,    26,    -1,    -1,    29,    30,    31,    -1,    33,    -1,
      -1,    -1,    -1,    38,    39,    -1,    41,    -1,    -1,    44,
      -1,    -1,    -1,    48,    -1,    50,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    58,    -1,    60,    61,    -1,    63,    -1,
      -1,    66,    -1,    68,    69,    70,    71,    72,     6,    -1,
      75,    -1,    10,    11,    -1,    13,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    24,    -1,    -1,    -1,
      -1,    29,    30,    31,    -1,    33,    -1,    -1,    36,    -1,
      38,    39,    -1,    41,    -1,    -1,    44,    -1,    -1,    -1,
      48,    -1,    50,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      58,    -1,    60,    61,    -1,    63,    -1,    -1,    66,    -1,
      68,    69,    70,    71,    72,     6,    -1,    75,    -1,    10,
      11,    -1,    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    24,    -1,    -1,    -1,    -1,    29,    30,
      31,    -1,    33,    -1,    -1,    -1,    -1,    38,    39,    -1,
      41,    -1,    -1,    44,    -1,    -1,    -1,    48,    -1,    50,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    58,    -1,    60,
      61,    -1,    63,    -1,    -1,    66,    -1,    68,    69,    70,
      71,    72,     6,    -1,    75,    -1,    10,    11,    -1,    13,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      24,    25,    26,    -1,    -1,    29,    30,    31,    -1,    33,
      -1,    -1,    -1,    -1,    38,    39,    -1,    41,    -1,    -1,
      44,    -1,    -1,    -1,    48,    -1,    50,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    58,    -1,    60,    61,    -1,    63,
      -1,    -1,    66,    -1,    68,    69,    70,    71,    72,     6,
      -1,    -1,    -1,    10,    11,    -1,    13,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    24,    -1,    -1,
      -1,    -1,    29,    30,    31,    -1,    33,    -1,    -1,    -1,
      -1,    38,    39,    -1,    41,    42,    -1,    44,    -1,    -1,
      -1,    48,    -1,    50,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    58,    -1,    60,    61,    -1,    63,    -1,    -1,    66,
      -1,    68,    69,    70,    71,    72,     6,    -1,    -1,    -1,
      10,    11,    -1,    13,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    24,    -1,    -1,    -1,    -1,    29,
      30,    31,    -1,    33,    -1,    -1,    -1,    -1,    38,    39,
      40,    41,    -1,    -1,    44,    -1,    -1,    -1,    48,    -1,
      50,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    58,    -1,
      60,    61,    -1,    63,    -1,    -1,    66,    -1,    68,    69,
      70,    71,    72,     6,    -1,    -1,    -1,    10,    11,    -1,
      13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    24,    -1,    -1,    -1,    -1,    29,    30,    31,    -1,
      33,    -1,    -1,    36,    -1,    38,    39,    -1,    41,    -1,
      -1,    44,    -1,    -1,    -1,    48,    -1,    50,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    58,    -1,    60,    61,    -1,
      63,    -1,    -1,    66,    -1,    68,    69,    70,    71,    72,
       6,    -1,    -1,    -1,    10,    11,    -1,    13,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    24,    -1,
      -1,    -1,    -1,    29,    30,    31,    -1,    33,    -1,    -1,
      -1,    -1,    38,    39,    -1,    41,    -1,    -1,    44,    -1,
      -1,    -1,    48,    -1,    50,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    58,    -1,    60,    61,    62,    63,    -1,    -1,
      66,    -1,    68,    69,    70,    71,    72
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,    53,    92,    93,     6,    11,    13,    14,    15,
      16,    54,    55,    56,    59,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    79,    82,    86,    95,   102,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   143,   153,    70,
       0,    94,   124,    66,   129,   153,   137,   137,     4,    21,
      20,    19,    18,    17,     7,     8,     9,    22,    76,    83,
      84,    85,    82,    86,    23,    87,    88,    89,    90,     5,
      77,    80,   119,     4,    75,   154,    10,    24,    29,    30,
      31,    33,    38,    39,    41,    44,    48,    50,    57,    58,
      60,    61,    63,    75,    99,   100,   101,   112,   139,   144,
     147,   148,   149,    78,   125,   126,   127,   128,   129,   131,
     131,   131,   131,   131,   131,   131,   132,   133,   133,   134,
     135,   136,   136,   137,    81,   121,   124,    66,   154,   154,
     138,   107,   108,   153,   104,   105,   153,    32,   103,   124,
      25,    26,    41,    44,    71,   124,    39,    43,   110,   154,
      46,   153,    49,   124,   153,   139,    68,    69,   100,     4,
      75,    76,   120,   121,    25,    26,   121,    78,    81,    81,
      76,    81,     5,    77,    66,    37,   154,   124,    97,    98,
     101,   153,    76,   124,   154,   154,    76,    64,    65,   100,
     124,   153,   153,   121,   107,    82,   109,   140,   104,    73,
      79,   106,   142,    77,     4,   100,    97,   154,    42,   154,
      47,   124,   154,    97,    30,   145,   146,   147,   148,   149,
     124,    62,    79,     5,    77,   122,   150,   150,   141,    78,
      81,   121,    97,    34,    36,   113,    40,    97,   110,    98,
     124,    45,    49,   118,    36,   105,    36,   154,   154,    71,
      66,    51,    52,   151,   152,   153,   154,   154,   106,    78,
      35,   114,   115,   116,   100,    33,    42,   124,   154,   124,
      34,   123,   124,    36,    50,   154,    57,   145,   145,    27,
      28,    58,   154,   153,   153,    78,    81,   122,    96,    99,
     100,    96,   124,    34,   117,   115,   113,    97,    72,   111,
     154,   154,    81,    48,   145,   154,    66,    66,    66,   145,
     122,   122,   151,    36,    96,    36,    37,     4,    36,    62,
     124,   154,    97,    97,   123,   150,    77,    77,    25,    26,
       4,    97,    33,    97,   118,   154,   152,   152,    97,    62,
      96,    78,    78,    36,   154,   154,    71,    96,    96,    36,
      36,    71,    71
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    91,    92,    92,    93,    93,    94,    94,    94,    95,
      95,    96,    96,    96,    97,    97,    98,    98,    99,   100,
     100,   100,   100,   100,   101,   101,   101,   101,   101,   101,
     101,   101,   101,   101,   101,   101,   101,   101,   101,   101,
     101,   101,   101,   101,   101,   101,   101,   101,   101,   102,
     102,   102,   103,   103,   104,   104,   105,   105,   105,   106,
     106,   107,   107,   108,   109,   109,   110,   110,   111,   111,
     112,   112,   112,   113,   113,   114,   114,   115,   115,   116,
     117,   117,   118,   118,   118,   119,   119,   120,   120,   121,
     121,   121,   122,   122,   123,   123,   124,   124,   125,   125,
     126,   126,   127,   127,   128,   128,   129,   129,   130,   130,
     130,   130,   130,   130,   130,   130,   131,   131,   132,   132,
     132,   133,   133,   134,   134,   135,   135,   135,   136,   136,
     137,   137,   137,   138,   138,   138,   139,   139,   139,   140,
     140,   140,   140,   140,   140,   140,   141,   141,   141,   142,
     142,   143,   143,   144,   145,   145,   145,   145,   145,   145,
     145,   145,   145,   146,   146,   146,   147,   147,   148,   148,
     149,   149,   149,   150,   150,   151,   151,   152,   152,   152,
     153,   153,   153,   153,   153,   153,   154,   154,   154,   154
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     2,     2,     0,     3,     0,     2,     2,     0,
       2,     0,     1,     2,     0,     1,     2,     3,     2,     1,
       2,     1,     3,     2,     2,     2,     3,     2,     6,     1,
       5,     6,     6,     4,     1,     2,     2,     2,     2,     2,
       4,     1,     4,     4,     2,    10,     8,     7,     6,     1,
       3,     2,     0,     1,     1,     3,     1,     4,     2,     1,
       3,     1,     3,     3,     1,     2,     1,     1,     0,     2,
       9,     5,     7,     0,     2,     0,     1,     1,     2,     5,
       0,     3,     0,     4,     5,     1,     3,     0,     1,     1,
       3,     2,     0,     1,     1,     3,     1,     3,     1,     3,
       1,     3,     1,     3,     1,     3,     1,     2,     1,     3,
       3,     3,     3,     3,     3,     3,     1,     3,     1,     3,
       3,     1,     3,     1,     3,     1,     3,     3,     1,     3,
       1,     2,     2,     1,     1,     2,     1,     1,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     7,     0,     1,     3,     2,     4,     2,
       4,     1,     3,     9,    11,    11,     8,     8,     0,     1,
       2,     1,     1,     1,     3,     1,     3,     2,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     2
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (&yylloc, ctx, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YY_LOCATION_PRINT
#  if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#   define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

#  else
#   define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#  endif
# endif /* !defined YY_LOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location, ctx); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, parser_ctx_t *ctx)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  YYUSE (yylocationp);
  YYUSE (ctx);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, parser_ctx_t *ctx)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YY_LOCATION_PRINT (yyo, *yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp, ctx);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule, parser_ctx_t *ctx)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]), ctx);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule, ctx); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, parser_ctx_t *ctx)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (ctx);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}






/*----------.
| yyparse.  |
`----------*/

int
yyparse (parser_ctx_t *ctx)
{
/* Lookahead token kind.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs = 0;

    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (&yylval, &yylloc, ctx);
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 3: /* Program: tEXPRESSION ExpressionNl_opt  */
#line 156 "dlls/vbscript/parser.y"
                                            { handle_isexpression_script(ctx, (yyvsp[0].expression)); }
#line 2003 "dlls/vbscript/parser.tab.c"
    break;

  case 5: /* OptionExplicit_opt: tOPTION tEXPLICIT StSep  */
#line 160 "dlls/vbscript/parser.y"
                                            { ctx->option_explicit = TRUE; }
#line 2009 "dlls/vbscript/parser.tab.c"
    break;

  case 7: /* SourceElements: SourceElements StatementNl  */
#line 164 "dlls/vbscript/parser.y"
                                            { source_add_statement(ctx, (yyvsp[0].statement)); }
#line 2015 "dlls/vbscript/parser.tab.c"
    break;

  case 8: /* SourceElements: SourceElements ClassDeclaration  */
#line 165 "dlls/vbscript/parser.y"
                                            { source_add_class(ctx, (yyvsp[0].class_decl)); }
#line 2021 "dlls/vbscript/parser.tab.c"
    break;

  case 9: /* ExpressionNl_opt: %empty  */
#line 168 "dlls/vbscript/parser.y"
                                            { (yyval.expression) = NULL; }
#line 2027 "dlls/vbscript/parser.tab.c"
    break;

  case 10: /* ExpressionNl_opt: Expression tNL  */
#line 169 "dlls/vbscript/parser.y"
                                            { (yyval.expression) = (yyvsp[-1].expression); }
#line 2033 "dlls/vbscript/parser.tab.c"
    break;

  case 11: /* BodyStatements: %empty  */
#line 172 "dlls/vbscript/parser.y"
                                            { (yyval.statement) = NULL; }
#line 2039 "dlls/vbscript/parser.tab.c"
    break;

  case 12: /* BodyStatements: Statement  */
#line 173 "dlls/vbscript/parser.y"
                                            { (yyval.statement) = (yyvsp[0].statement); }
#line 2045 "dlls/vbscript/parser.tab.c"
    break;

  case 13: /* BodyStatements: StatementNl BodyStatements  */
#line 174 "dlls/vbscript/parser.y"
                                            { (yyval.statement) = link_statements((yyvsp[-1].statement), (yyvsp[0].statement)); }
#line 2051 "dlls/vbscript/parser.tab.c"
    break;

  case 14: /* StatementsNl_opt: %empty  */
#line 177 "dlls/vbscript/parser.y"
                                            { (yyval.statement) = NULL; }
#line 2057 "dlls/vbscript/parser.tab.c"
    break;

  case 15: /* StatementsNl_opt: StatementsNl  */
#line 178 "dlls/vbscript/parser.y"
                                            { (yyval.statement) = (yyvsp[0].statement); }
#line 2063 "dlls/vbscript/parser.tab.c"
    break;

  case 16: /* StatementsNl: SimpleStatement StSep  */
#line 181 "dlls/vbscript/parser.y"
                                            { (yyval.statement) = (yyvsp[-1].statement); }
#line 2069 "dlls/vbscript/parser.tab.c"
    break;

  case 17: /* StatementsNl: SimpleStatement StSep StatementsNl  */
#line 182 "dlls/vbscript/parser.y"
                                            { (yyval.statement) = link_statements((yyvsp[-2].statement), (yyvsp[0].statement)); }
#line 2075 "dlls/vbscript/parser.tab.c"
    break;

  case 18: /* StatementNl: Statement tNL  */
#line 185 "dlls/vbscript/parser.y"
                                            { (yyval.statement) = (yyvsp[-1].statement); }
#line 2081 "dlls/vbscript/parser.tab.c"
    break;

  case 19: /* Statement: ':'  */
#line 188 "dlls/vbscript/parser.y"
                                            { (yyval.statement) = NULL; }
#line 2087 "dlls/vbscript/parser.tab.c"
    break;

  case 20: /* Statement: ':' Statement  */
#line 189 "dlls/vbscript/parser.y"
                                            { (yyval.statement) = (yyvsp[0].statement); }
#line 2093 "dlls/vbscript/parser.tab.c"
    break;

  case 21: /* Statement: SimpleStatement  */
#line 190 "dlls/vbscript/parser.y"
                                            { (yyval.statement) = (yyvsp[0].statement); }
#line 2099 "dlls/vbscript/parser.tab.c"
    break;

  case 22: /* Statement: SimpleStatement ':' Statement  */
#line 191 "dlls/vbscript/parser.y"
                                            { (yyvsp[-2].statement)->next = (yyvsp[0].statement); (yyval.statement) = (yyvsp[-2].statement); }
#line 2105 "dlls/vbscript/parser.tab.c"
    break;

  case 23: /* Statement: SimpleStatement ':'  */
#line 192 "dlls/vbscript/parser.y"
                                            { (yyval.statement) = (yyvsp[-1].statement); }
#line 2111 "dlls/vbscript/parser.tab.c"
    break;

  case 24: /* SimpleStatement: CallExpression ArgumentList_opt  */
#line 195 "dlls/vbscript/parser.y"
                                            { call_expression_t *call_expr = make_call_expression(ctx, (yyvsp[-1].expression), (yyvsp[0].expression)); CHECK_ERROR;
                                              (yyval.statement) = new_call_statement(ctx, (yyloc), FALSE, &call_expr->expr); CHECK_ERROR; }
#line 2118 "dlls/vbscript/parser.tab.c"
    break;

  case 25: /* SimpleStatement: tCALL UnaryExpression  */
#line 197 "dlls/vbscript/parser.y"
                                            { (yyval.statement) = new_call_statement(ctx, (yyloc), TRUE, (yyvsp[0].expression)); CHECK_ERROR; }
#line 2124 "dlls/vbscript/parser.tab.c"
    break;

  case 26: /* SimpleStatement: CallExpression '=' Expression  */
#line 199 "dlls/vbscript/parser.y"
                                            { (yyval.statement) = new_assign_statement(ctx, (yyloc), (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2130 "dlls/vbscript/parser.tab.c"
    break;

  case 27: /* SimpleStatement: tDIM DimDeclList  */
#line 200 "dlls/vbscript/parser.y"
                                            { (yyval.statement) = new_dim_statement(ctx, (yyloc), (yyvsp[0].dim_decl)); CHECK_ERROR; }
#line 2136 "dlls/vbscript/parser.tab.c"
    break;

  case 28: /* SimpleStatement: tREDIM Preserve_opt tIdentifier '(' ArgumentList ')'  */
#line 202 "dlls/vbscript/parser.y"
                                            { (yyval.statement) = new_redim_statement(ctx, (yyloc), (yyvsp[-3].string), (yyvsp[-4].boolean), (yyvsp[-1].expression)); CHECK_ERROR; }
#line 2142 "dlls/vbscript/parser.tab.c"
    break;

  case 29: /* SimpleStatement: IfStatement  */
#line 203 "dlls/vbscript/parser.y"
                                            { (yyval.statement) = (yyvsp[0].statement); }
#line 2148 "dlls/vbscript/parser.tab.c"
    break;

  case 30: /* SimpleStatement: tWHILE Expression StSep StatementsNl_opt tWEND  */
#line 205 "dlls/vbscript/parser.y"
                                            { (yyval.statement) = new_while_statement(ctx, (yyloc), STAT_WHILE, (yyvsp[-3].expression), (yyvsp[-1].statement)); CHECK_ERROR; }
#line 2154 "dlls/vbscript/parser.tab.c"
    break;

  case 31: /* SimpleStatement: tDO DoType Expression StSep StatementsNl_opt tLOOP  */
#line 207 "dlls/vbscript/parser.y"
                                            { (yyval.statement) = new_while_statement(ctx, (yyloc), (yyvsp[-4].boolean) ? STAT_WHILELOOP : STAT_UNTIL, (yyvsp[-3].expression), (yyvsp[-1].statement));
                                              CHECK_ERROR; }
#line 2161 "dlls/vbscript/parser.tab.c"
    break;

  case 32: /* SimpleStatement: tDO StSep StatementsNl_opt tLOOP DoType Expression  */
#line 210 "dlls/vbscript/parser.y"
                                            { (yyval.statement) = new_while_statement(ctx, (yylsp[-2]), (yyvsp[-1].boolean) ? STAT_DOWHILE : STAT_DOUNTIL, (yyvsp[0].expression), (yyvsp[-3].statement));
                                              CHECK_ERROR; }
#line 2168 "dlls/vbscript/parser.tab.c"
    break;

  case 33: /* SimpleStatement: tDO StSep StatementsNl_opt tLOOP  */
#line 212 "dlls/vbscript/parser.y"
                                            { (yyval.statement) = new_while_statement(ctx, (yyloc), STAT_DOWHILE, NULL, (yyvsp[-1].statement)); CHECK_ERROR; }
#line 2174 "dlls/vbscript/parser.tab.c"
    break;

  case 34: /* SimpleStatement: FunctionDecl  */
#line 213 "dlls/vbscript/parser.y"
                                            { (yyval.statement) = new_function_statement(ctx, (yyloc), (yyvsp[0].func_decl)); CHECK_ERROR; }
#line 2180 "dlls/vbscript/parser.tab.c"
    break;

  case 35: /* SimpleStatement: tEXIT tDO  */
#line 214 "dlls/vbscript/parser.y"
                                            { (yyval.statement) = new_statement(ctx, STAT_EXITDO, 0, (yyloc)); CHECK_ERROR; }
#line 2186 "dlls/vbscript/parser.tab.c"
    break;

  case 36: /* SimpleStatement: tEXIT tFOR  */
#line 215 "dlls/vbscript/parser.y"
                                            { (yyval.statement) = new_statement(ctx, STAT_EXITFOR, 0, (yyloc)); CHECK_ERROR; }
#line 2192 "dlls/vbscript/parser.tab.c"
    break;

  case 37: /* SimpleStatement: tEXIT tFUNCTION  */
#line 216 "dlls/vbscript/parser.y"
                                            { (yyval.statement) = new_statement(ctx, STAT_EXITFUNC, 0, (yyloc)); CHECK_ERROR; }
#line 2198 "dlls/vbscript/parser.tab.c"
    break;

  case 38: /* SimpleStatement: tEXIT tPROPERTY  */
#line 217 "dlls/vbscript/parser.y"
                                            { (yyval.statement) = new_statement(ctx, STAT_EXITPROP, 0, (yyloc)); CHECK_ERROR; }
#line 2204 "dlls/vbscript/parser.tab.c"
    break;

  case 39: /* SimpleStatement: tEXIT tSUB  */
#line 218 "dlls/vbscript/parser.y"
                                            { (yyval.statement) = new_statement(ctx, STAT_EXITSUB, 0, (yyloc)); CHECK_ERROR; }
#line 2210 "dlls/vbscript/parser.tab.c"
    break;

  case 40: /* SimpleStatement: tSET CallExpression '=' Expression  */
#line 219 "dlls/vbscript/parser.y"
                                            { (yyval.statement) = new_set_statement(ctx, (yyloc), (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2216 "dlls/vbscript/parser.tab.c"
    break;

  case 41: /* SimpleStatement: tSTOP  */
#line 220 "dlls/vbscript/parser.y"
                                            { (yyval.statement) = new_statement(ctx, STAT_STOP, 0, (yyloc)); CHECK_ERROR; }
#line 2222 "dlls/vbscript/parser.tab.c"
    break;

  case 42: /* SimpleStatement: tON tERROR tRESUME tNEXT  */
#line 221 "dlls/vbscript/parser.y"
                                            { (yyval.statement) = new_onerror_statement(ctx, (yyloc), TRUE); CHECK_ERROR; }
#line 2228 "dlls/vbscript/parser.tab.c"
    break;

  case 43: /* SimpleStatement: tON tERROR tGOTO '0'  */
#line 222 "dlls/vbscript/parser.y"
                                            { (yyval.statement) = new_onerror_statement(ctx, (yyloc), FALSE); CHECK_ERROR; }
#line 2234 "dlls/vbscript/parser.tab.c"
    break;

  case 44: /* SimpleStatement: tCONST ConstDeclList  */
#line 223 "dlls/vbscript/parser.y"
                                            { (yyval.statement) = new_const_statement(ctx, (yyloc), (yyvsp[0].const_decl)); CHECK_ERROR; }
#line 2240 "dlls/vbscript/parser.tab.c"
    break;

  case 45: /* SimpleStatement: tFOR Identifier '=' Expression tTO Expression Step_opt StSep StatementsNl_opt tNEXT  */
#line 225 "dlls/vbscript/parser.y"
                                            { (yyval.statement) = new_forto_statement(ctx, (yyloc), (yyvsp[-8].string), (yyvsp[-6].expression), (yyvsp[-4].expression), (yyvsp[-3].expression), (yyvsp[-1].statement)); CHECK_ERROR; }
#line 2246 "dlls/vbscript/parser.tab.c"
    break;

  case 46: /* SimpleStatement: tFOR tEACH Identifier tIN Expression StSep StatementsNl_opt tNEXT  */
#line 227 "dlls/vbscript/parser.y"
                                            { (yyval.statement) = new_foreach_statement(ctx, (yyloc), (yyvsp[-5].string), (yyvsp[-3].expression), (yyvsp[-1].statement)); }
#line 2252 "dlls/vbscript/parser.tab.c"
    break;

  case 47: /* SimpleStatement: tSELECT tCASE Expression StSep CaseClausules tEND tSELECT  */
#line 229 "dlls/vbscript/parser.y"
                                            { (yyval.statement) = new_select_statement(ctx, (yyloc), (yyvsp[-4].expression), (yyvsp[-2].case_clausule)); }
#line 2258 "dlls/vbscript/parser.tab.c"
    break;

  case 48: /* SimpleStatement: tWITH Expression StSep StatementsNl_opt tEND tWITH  */
#line 231 "dlls/vbscript/parser.y"
                                            { (yyval.statement) = new_with_statement(ctx, (yyloc), (yyvsp[-4].expression), (yyvsp[-2].statement)); }
#line 2264 "dlls/vbscript/parser.tab.c"
    break;

  case 49: /* MemberExpression: Identifier  */
#line 234 "dlls/vbscript/parser.y"
                                            { (yyval.member) = new_member_expression(ctx, NULL, (yyvsp[0].string)); CHECK_ERROR; }
#line 2270 "dlls/vbscript/parser.tab.c"
    break;

  case 50: /* MemberExpression: CallExpression '.' tIdentifier  */
#line 235 "dlls/vbscript/parser.y"
                                            { (yyval.member) = new_member_expression(ctx, (yyvsp[-2].expression), (yyvsp[0].string)); CHECK_ERROR; }
#line 2276 "dlls/vbscript/parser.tab.c"
    break;

  case 51: /* MemberExpression: tDOT tIdentifier  */
#line 236 "dlls/vbscript/parser.y"
                                            { expression_t *dot_expr = new_expression(ctx, EXPR_DOT, sizeof(*dot_expr)); CHECK_ERROR;
                                              (yyval.member) = new_member_expression(ctx, dot_expr, (yyvsp[0].string)); CHECK_ERROR; }
#line 2283 "dlls/vbscript/parser.tab.c"
    break;

  case 52: /* Preserve_opt: %empty  */
#line 240 "dlls/vbscript/parser.y"
                                            { (yyval.boolean) = FALSE; }
#line 2289 "dlls/vbscript/parser.tab.c"
    break;

  case 53: /* Preserve_opt: tPRESERVE  */
#line 241 "dlls/vbscript/parser.y"
                                            { (yyval.boolean) = TRUE; }
#line 2295 "dlls/vbscript/parser.tab.c"
    break;

  case 54: /* DimDeclList: DimDecl  */
#line 244 "dlls/vbscript/parser.y"
                                            { (yyval.dim_decl) = (yyvsp[0].dim_decl); }
#line 2301 "dlls/vbscript/parser.tab.c"
    break;

  case 55: /* DimDeclList: DimDecl ',' DimDeclList  */
#line 245 "dlls/vbscript/parser.y"
                                            { (yyvsp[-2].dim_decl)->next = (yyvsp[0].dim_decl); (yyval.dim_decl) = (yyvsp[-2].dim_decl); }
#line 2307 "dlls/vbscript/parser.tab.c"
    break;

  case 56: /* DimDecl: Identifier  */
#line 248 "dlls/vbscript/parser.y"
                                            { (yyval.dim_decl) = new_dim_decl(ctx, (yyvsp[0].string), FALSE, NULL); CHECK_ERROR; }
#line 2313 "dlls/vbscript/parser.tab.c"
    break;

  case 57: /* DimDecl: Identifier '(' DimList ')'  */
#line 249 "dlls/vbscript/parser.y"
                                            { (yyval.dim_decl) = new_dim_decl(ctx, (yyvsp[-3].string), TRUE, (yyvsp[-1].dim_list)); CHECK_ERROR; }
#line 2319 "dlls/vbscript/parser.tab.c"
    break;

  case 58: /* DimDecl: Identifier tEMPTYBRACKETS  */
#line 250 "dlls/vbscript/parser.y"
                                            { (yyval.dim_decl) = new_dim_decl(ctx, (yyvsp[-1].string), TRUE, NULL); CHECK_ERROR; }
#line 2325 "dlls/vbscript/parser.tab.c"
    break;

  case 59: /* DimList: IntegerValue  */
#line 253 "dlls/vbscript/parser.y"
                                            { (yyval.dim_list) = new_dim(ctx, (yyvsp[0].uint), NULL); }
#line 2331 "dlls/vbscript/parser.tab.c"
    break;

  case 60: /* DimList: IntegerValue ',' DimList  */
#line 254 "dlls/vbscript/parser.y"
                                            { (yyval.dim_list) = new_dim(ctx, (yyvsp[-2].uint), (yyvsp[0].dim_list)); }
#line 2337 "dlls/vbscript/parser.tab.c"
    break;

  case 61: /* ConstDeclList: ConstDecl  */
#line 257 "dlls/vbscript/parser.y"
                                            { (yyval.const_decl) = (yyvsp[0].const_decl); }
#line 2343 "dlls/vbscript/parser.tab.c"
    break;

  case 62: /* ConstDeclList: ConstDecl ',' ConstDeclList  */
#line 258 "dlls/vbscript/parser.y"
                                            { (yyvsp[-2].const_decl)->next = (yyvsp[0].const_decl); (yyval.const_decl) = (yyvsp[-2].const_decl); }
#line 2349 "dlls/vbscript/parser.tab.c"
    break;

  case 63: /* ConstDecl: Identifier '=' ConstExpression  */
#line 261 "dlls/vbscript/parser.y"
                                            { (yyval.const_decl) = new_const_decl(ctx, (yyvsp[-2].string), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2355 "dlls/vbscript/parser.tab.c"
    break;

  case 64: /* ConstExpression: LiteralExpression  */
#line 264 "dlls/vbscript/parser.y"
                                            { (yyval.expression) = (yyvsp[0].expression); }
#line 2361 "dlls/vbscript/parser.tab.c"
    break;

  case 65: /* ConstExpression: '-' NumericLiteralExpression  */
#line 265 "dlls/vbscript/parser.y"
                                            { (yyval.expression) = new_unary_expression(ctx, EXPR_NEG, (yyvsp[0].expression)); CHECK_ERROR; }
#line 2367 "dlls/vbscript/parser.tab.c"
    break;

  case 66: /* DoType: tWHILE  */
#line 268 "dlls/vbscript/parser.y"
                    { (yyval.boolean) = TRUE; }
#line 2373 "dlls/vbscript/parser.tab.c"
    break;

  case 67: /* DoType: tUNTIL  */
#line 269 "dlls/vbscript/parser.y"
                    { (yyval.boolean) = FALSE; }
#line 2379 "dlls/vbscript/parser.tab.c"
    break;

  case 68: /* Step_opt: %empty  */
#line 272 "dlls/vbscript/parser.y"
                                            { (yyval.expression) = NULL;}
#line 2385 "dlls/vbscript/parser.tab.c"
    break;

  case 69: /* Step_opt: tSTEP Expression  */
#line 273 "dlls/vbscript/parser.y"
                                            { (yyval.expression) = (yyvsp[0].expression); }
#line 2391 "dlls/vbscript/parser.tab.c"
    break;

  case 70: /* IfStatement: tIF Expression tTHEN tNL StatementsNl_opt ElseIfs_opt Else_opt tEND tIF  */
#line 277 "dlls/vbscript/parser.y"
                                               { (yyval.statement) = new_if_statement(ctx, (yyloc), (yyvsp[-7].expression), (yyvsp[-4].statement), (yyvsp[-3].elseif), (yyvsp[-2].statement)); CHECK_ERROR; }
#line 2397 "dlls/vbscript/parser.tab.c"
    break;

  case 71: /* IfStatement: tIF Expression tTHEN Statement EndIf_opt  */
#line 278 "dlls/vbscript/parser.y"
                                               { (yyval.statement) = new_if_statement(ctx, (yyloc), (yyvsp[-3].expression), (yyvsp[-1].statement), NULL, NULL); CHECK_ERROR; }
#line 2403 "dlls/vbscript/parser.tab.c"
    break;

  case 72: /* IfStatement: tIF Expression tTHEN Statement tELSE Statement EndIf_opt  */
#line 280 "dlls/vbscript/parser.y"
                                               { (yyval.statement) = new_if_statement(ctx, (yyloc), (yyvsp[-5].expression), (yyvsp[-3].statement), NULL, (yyvsp[-1].statement)); CHECK_ERROR; }
#line 2409 "dlls/vbscript/parser.tab.c"
    break;

  case 75: /* ElseIfs_opt: %empty  */
#line 287 "dlls/vbscript/parser.y"
                                            { (yyval.elseif) = NULL; }
#line 2415 "dlls/vbscript/parser.tab.c"
    break;

  case 76: /* ElseIfs_opt: ElseIfs  */
#line 288 "dlls/vbscript/parser.y"
                                            { (yyval.elseif) = (yyvsp[0].elseif); }
#line 2421 "dlls/vbscript/parser.tab.c"
    break;

  case 77: /* ElseIfs: ElseIf  */
#line 291 "dlls/vbscript/parser.y"
                                            { (yyval.elseif) = (yyvsp[0].elseif); }
#line 2427 "dlls/vbscript/parser.tab.c"
    break;

  case 78: /* ElseIfs: ElseIf ElseIfs  */
#line 292 "dlls/vbscript/parser.y"
                                            { (yyvsp[-1].elseif)->next = (yyvsp[0].elseif); (yyval.elseif) = (yyvsp[-1].elseif); }
#line 2433 "dlls/vbscript/parser.tab.c"
    break;

  case 79: /* ElseIf: tELSEIF Expression tTHEN tNL StatementsNl_opt  */
#line 296 "dlls/vbscript/parser.y"
                                            { (yyval.elseif) = new_elseif_decl(ctx, (yyloc), (yyvsp[-3].expression), (yyvsp[0].statement)); }
#line 2439 "dlls/vbscript/parser.tab.c"
    break;

  case 80: /* Else_opt: %empty  */
#line 299 "dlls/vbscript/parser.y"
                                            { (yyval.statement) = NULL; }
#line 2445 "dlls/vbscript/parser.tab.c"
    break;

  case 81: /* Else_opt: tELSE tNL StatementsNl_opt  */
#line 300 "dlls/vbscript/parser.y"
                                            { (yyval.statement) = (yyvsp[0].statement); }
#line 2451 "dlls/vbscript/parser.tab.c"
    break;

  case 82: /* CaseClausules: %empty  */
#line 303 "dlls/vbscript/parser.y"
                                           { (yyval.case_clausule) = NULL; }
#line 2457 "dlls/vbscript/parser.tab.c"
    break;

  case 83: /* CaseClausules: tCASE tELSE StSep StatementsNl_opt  */
#line 304 "dlls/vbscript/parser.y"
                                           { (yyval.case_clausule) = new_case_clausule(ctx, NULL, (yyvsp[0].statement), NULL); }
#line 2463 "dlls/vbscript/parser.tab.c"
    break;

  case 84: /* CaseClausules: tCASE ExpressionList StSep StatementsNl_opt CaseClausules  */
#line 306 "dlls/vbscript/parser.y"
                                           { (yyval.case_clausule) = new_case_clausule(ctx, (yyvsp[-3].expression), (yyvsp[-1].statement), (yyvsp[0].case_clausule)); }
#line 2469 "dlls/vbscript/parser.tab.c"
    break;

  case 85: /* Arguments: tEMPTYBRACKETS  */
#line 309 "dlls/vbscript/parser.y"
                                    { (yyval.expression) = NULL; }
#line 2475 "dlls/vbscript/parser.tab.c"
    break;

  case 86: /* Arguments: '(' ArgumentList ')'  */
#line 310 "dlls/vbscript/parser.y"
                                    { (yyval.expression) = (yyvsp[-1].expression); }
#line 2481 "dlls/vbscript/parser.tab.c"
    break;

  case 87: /* ArgumentList_opt: %empty  */
#line 313 "dlls/vbscript/parser.y"
                                    { (yyval.expression) = NULL; }
#line 2487 "dlls/vbscript/parser.tab.c"
    break;

  case 88: /* ArgumentList_opt: ArgumentList  */
#line 314 "dlls/vbscript/parser.y"
                                    { (yyval.expression) = (yyvsp[0].expression); }
#line 2493 "dlls/vbscript/parser.tab.c"
    break;

  case 89: /* ArgumentList: Expression  */
#line 317 "dlls/vbscript/parser.y"
                                    { (yyval.expression) = (yyvsp[0].expression); }
#line 2499 "dlls/vbscript/parser.tab.c"
    break;

  case 90: /* ArgumentList: Expression ',' ArgumentList  */
#line 318 "dlls/vbscript/parser.y"
                                    { (yyvsp[-2].expression)->next = (yyvsp[0].expression); (yyval.expression) = (yyvsp[-2].expression); }
#line 2505 "dlls/vbscript/parser.tab.c"
    break;

  case 91: /* ArgumentList: ',' ArgumentList  */
#line 319 "dlls/vbscript/parser.y"
                                    { (yyval.expression) = new_expression(ctx, EXPR_NOARG, 0); CHECK_ERROR; (yyval.expression)->next = (yyvsp[0].expression); }
#line 2511 "dlls/vbscript/parser.tab.c"
    break;

  case 94: /* ExpressionList: Expression  */
#line 326 "dlls/vbscript/parser.y"
                                    { (yyval.expression) = (yyvsp[0].expression); }
#line 2517 "dlls/vbscript/parser.tab.c"
    break;

  case 95: /* ExpressionList: Expression ',' ExpressionList  */
#line 327 "dlls/vbscript/parser.y"
                                    { (yyvsp[-2].expression)->next = (yyvsp[0].expression); (yyval.expression) = (yyvsp[-2].expression); }
#line 2523 "dlls/vbscript/parser.tab.c"
    break;

  case 96: /* Expression: EqvExpression  */
#line 330 "dlls/vbscript/parser.y"
                                                { (yyval.expression) = (yyvsp[0].expression); }
#line 2529 "dlls/vbscript/parser.tab.c"
    break;

  case 97: /* Expression: Expression tIMP EqvExpression  */
#line 331 "dlls/vbscript/parser.y"
                                                { (yyval.expression) = new_binary_expression(ctx, EXPR_IMP, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2535 "dlls/vbscript/parser.tab.c"
    break;

  case 98: /* EqvExpression: XorExpression  */
#line 334 "dlls/vbscript/parser.y"
                                                { (yyval.expression) = (yyvsp[0].expression); }
#line 2541 "dlls/vbscript/parser.tab.c"
    break;

  case 99: /* EqvExpression: EqvExpression tEQV XorExpression  */
#line 335 "dlls/vbscript/parser.y"
                                                { (yyval.expression) = new_binary_expression(ctx, EXPR_EQV, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2547 "dlls/vbscript/parser.tab.c"
    break;

  case 100: /* XorExpression: OrExpression  */
#line 338 "dlls/vbscript/parser.y"
                                                { (yyval.expression) = (yyvsp[0].expression); }
#line 2553 "dlls/vbscript/parser.tab.c"
    break;

  case 101: /* XorExpression: XorExpression tXOR OrExpression  */
#line 339 "dlls/vbscript/parser.y"
                                                { (yyval.expression) = new_binary_expression(ctx, EXPR_XOR, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2559 "dlls/vbscript/parser.tab.c"
    break;

  case 102: /* OrExpression: AndExpression  */
#line 342 "dlls/vbscript/parser.y"
                                                { (yyval.expression) = (yyvsp[0].expression); }
#line 2565 "dlls/vbscript/parser.tab.c"
    break;

  case 103: /* OrExpression: OrExpression tOR AndExpression  */
#line 343 "dlls/vbscript/parser.y"
                                                { (yyval.expression) = new_binary_expression(ctx, EXPR_OR, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2571 "dlls/vbscript/parser.tab.c"
    break;

  case 104: /* AndExpression: NotExpression  */
#line 346 "dlls/vbscript/parser.y"
                                                { (yyval.expression) = (yyvsp[0].expression); }
#line 2577 "dlls/vbscript/parser.tab.c"
    break;

  case 105: /* AndExpression: AndExpression tAND NotExpression  */
#line 347 "dlls/vbscript/parser.y"
                                                { (yyval.expression) = new_binary_expression(ctx, EXPR_AND, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2583 "dlls/vbscript/parser.tab.c"
    break;

  case 106: /* NotExpression: EqualityExpression  */
#line 350 "dlls/vbscript/parser.y"
                                    { (yyval.expression) = (yyvsp[0].expression); }
#line 2589 "dlls/vbscript/parser.tab.c"
    break;

  case 107: /* NotExpression: tNOT NotExpression  */
#line 351 "dlls/vbscript/parser.y"
                                    { (yyval.expression) = new_unary_expression(ctx, EXPR_NOT, (yyvsp[0].expression)); CHECK_ERROR; }
#line 2595 "dlls/vbscript/parser.tab.c"
    break;

  case 108: /* EqualityExpression: ConcatExpression  */
#line 354 "dlls/vbscript/parser.y"
                                                { (yyval.expression) = (yyvsp[0].expression); }
#line 2601 "dlls/vbscript/parser.tab.c"
    break;

  case 109: /* EqualityExpression: EqualityExpression '=' ConcatExpression  */
#line 355 "dlls/vbscript/parser.y"
                                                { (yyval.expression) = new_binary_expression(ctx, EXPR_EQUAL, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2607 "dlls/vbscript/parser.tab.c"
    break;

  case 110: /* EqualityExpression: EqualityExpression tNEQ ConcatExpression  */
#line 356 "dlls/vbscript/parser.y"
                                                { (yyval.expression) = new_binary_expression(ctx, EXPR_NEQUAL, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2613 "dlls/vbscript/parser.tab.c"
    break;

  case 111: /* EqualityExpression: EqualityExpression '>' ConcatExpression  */
#line 357 "dlls/vbscript/parser.y"
                                                { (yyval.expression) = new_binary_expression(ctx, EXPR_GT, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2619 "dlls/vbscript/parser.tab.c"
    break;

  case 112: /* EqualityExpression: EqualityExpression '<' ConcatExpression  */
#line 358 "dlls/vbscript/parser.y"
                                                { (yyval.expression) = new_binary_expression(ctx, EXPR_LT, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2625 "dlls/vbscript/parser.tab.c"
    break;

  case 113: /* EqualityExpression: EqualityExpression tGTEQ ConcatExpression  */
#line 359 "dlls/vbscript/parser.y"
                                                { (yyval.expression) = new_binary_expression(ctx, EXPR_GTEQ, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2631 "dlls/vbscript/parser.tab.c"
    break;

  case 114: /* EqualityExpression: EqualityExpression tLTEQ ConcatExpression  */
#line 360 "dlls/vbscript/parser.y"
                                                { (yyval.expression) = new_binary_expression(ctx, EXPR_LTEQ, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2637 "dlls/vbscript/parser.tab.c"
    break;

  case 115: /* EqualityExpression: EqualityExpression tIS ConcatExpression  */
#line 361 "dlls/vbscript/parser.y"
                                                { (yyval.expression) = new_binary_expression(ctx, EXPR_IS, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2643 "dlls/vbscript/parser.tab.c"
    break;

  case 116: /* ConcatExpression: AdditiveExpression  */
#line 364 "dlls/vbscript/parser.y"
                                                { (yyval.expression) = (yyvsp[0].expression); }
#line 2649 "dlls/vbscript/parser.tab.c"
    break;

  case 117: /* ConcatExpression: ConcatExpression '&' AdditiveExpression  */
#line 365 "dlls/vbscript/parser.y"
                                                { (yyval.expression) = new_binary_expression(ctx, EXPR_CONCAT, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2655 "dlls/vbscript/parser.tab.c"
    break;

  case 118: /* AdditiveExpression: ModExpression  */
#line 368 "dlls/vbscript/parser.y"
                                                { (yyval.expression) = (yyvsp[0].expression); }
#line 2661 "dlls/vbscript/parser.tab.c"
    break;

  case 119: /* AdditiveExpression: AdditiveExpression '+' ModExpression  */
#line 369 "dlls/vbscript/parser.y"
                                                { (yyval.expression) = new_binary_expression(ctx, EXPR_ADD, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2667 "dlls/vbscript/parser.tab.c"
    break;

  case 120: /* AdditiveExpression: AdditiveExpression '-' ModExpression  */
#line 370 "dlls/vbscript/parser.y"
                                                { (yyval.expression) = new_binary_expression(ctx, EXPR_SUB, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2673 "dlls/vbscript/parser.tab.c"
    break;

  case 121: /* ModExpression: IntdivExpression  */
#line 373 "dlls/vbscript/parser.y"
                                                { (yyval.expression) = (yyvsp[0].expression); }
#line 2679 "dlls/vbscript/parser.tab.c"
    break;

  case 122: /* ModExpression: ModExpression tMOD IntdivExpression  */
#line 374 "dlls/vbscript/parser.y"
                                                { (yyval.expression) = new_binary_expression(ctx, EXPR_MOD, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2685 "dlls/vbscript/parser.tab.c"
    break;

  case 123: /* IntdivExpression: MultiplicativeExpression  */
#line 377 "dlls/vbscript/parser.y"
                                                { (yyval.expression) = (yyvsp[0].expression); }
#line 2691 "dlls/vbscript/parser.tab.c"
    break;

  case 124: /* IntdivExpression: IntdivExpression '\\' MultiplicativeExpression  */
#line 379 "dlls/vbscript/parser.y"
                                                { (yyval.expression) = new_binary_expression(ctx, EXPR_IDIV, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2697 "dlls/vbscript/parser.tab.c"
    break;

  case 125: /* MultiplicativeExpression: ExpExpression  */
#line 382 "dlls/vbscript/parser.y"
                                                { (yyval.expression) = (yyvsp[0].expression); }
#line 2703 "dlls/vbscript/parser.tab.c"
    break;

  case 126: /* MultiplicativeExpression: MultiplicativeExpression '*' ExpExpression  */
#line 384 "dlls/vbscript/parser.y"
                                                { (yyval.expression) = new_binary_expression(ctx, EXPR_MUL, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2709 "dlls/vbscript/parser.tab.c"
    break;

  case 127: /* MultiplicativeExpression: MultiplicativeExpression '/' ExpExpression  */
#line 386 "dlls/vbscript/parser.y"
                                                { (yyval.expression) = new_binary_expression(ctx, EXPR_DIV, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2715 "dlls/vbscript/parser.tab.c"
    break;

  case 128: /* ExpExpression: SignExpression  */
#line 389 "dlls/vbscript/parser.y"
                                                { (yyval.expression) = (yyvsp[0].expression); }
#line 2721 "dlls/vbscript/parser.tab.c"
    break;

  case 129: /* ExpExpression: ExpExpression '^' SignExpression  */
#line 390 "dlls/vbscript/parser.y"
                                                { (yyval.expression) = new_binary_expression(ctx, EXPR_EXP, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2727 "dlls/vbscript/parser.tab.c"
    break;

  case 130: /* SignExpression: UnaryExpression  */
#line 393 "dlls/vbscript/parser.y"
                                    { (yyval.expression) = (yyvsp[0].expression); }
#line 2733 "dlls/vbscript/parser.tab.c"
    break;

  case 131: /* SignExpression: '-' SignExpression  */
#line 394 "dlls/vbscript/parser.y"
                                    { (yyval.expression) = new_unary_expression(ctx, EXPR_NEG, (yyvsp[0].expression)); CHECK_ERROR; }
#line 2739 "dlls/vbscript/parser.tab.c"
    break;

  case 132: /* SignExpression: '+' SignExpression  */
#line 395 "dlls/vbscript/parser.y"
                                    { (yyval.expression) = (yyvsp[0].expression); }
#line 2745 "dlls/vbscript/parser.tab.c"
    break;

  case 133: /* UnaryExpression: LiteralExpression  */
#line 398 "dlls/vbscript/parser.y"
                                    { (yyval.expression) = (yyvsp[0].expression); }
#line 2751 "dlls/vbscript/parser.tab.c"
    break;

  case 134: /* UnaryExpression: CallExpression  */
#line 399 "dlls/vbscript/parser.y"
                                    { (yyval.expression) = (yyvsp[0].expression); }
#line 2757 "dlls/vbscript/parser.tab.c"
    break;

  case 135: /* UnaryExpression: tNEW Identifier  */
#line 400 "dlls/vbscript/parser.y"
                                    { (yyval.expression) = new_new_expression(ctx, (yyvsp[0].string)); CHECK_ERROR; }
#line 2763 "dlls/vbscript/parser.tab.c"
    break;

  case 136: /* CallExpression: PrimaryExpression  */
#line 403 "dlls/vbscript/parser.y"
                                    { (yyval.expression) = (yyvsp[0].expression); }
#line 2769 "dlls/vbscript/parser.tab.c"
    break;

  case 137: /* CallExpression: MemberExpression  */
#line 404 "dlls/vbscript/parser.y"
                                    { (yyval.expression) = &(yyvsp[0].member)->expr; }
#line 2775 "dlls/vbscript/parser.tab.c"
    break;

  case 138: /* CallExpression: CallExpression Arguments  */
#line 405 "dlls/vbscript/parser.y"
                                    { call_expression_t *expr = new_call_expression(ctx, (yyvsp[-1].expression), (yyvsp[0].expression)); CHECK_ERROR;
                                      (yyval.expression) = &expr->expr; }
#line 2782 "dlls/vbscript/parser.tab.c"
    break;

  case 139: /* LiteralExpression: tTRUE  */
#line 409 "dlls/vbscript/parser.y"
                                    { (yyval.expression) = new_bool_expression(ctx, VARIANT_TRUE); CHECK_ERROR; }
#line 2788 "dlls/vbscript/parser.tab.c"
    break;

  case 140: /* LiteralExpression: tFALSE  */
#line 410 "dlls/vbscript/parser.y"
                                    { (yyval.expression) = new_bool_expression(ctx, VARIANT_FALSE); CHECK_ERROR; }
#line 2794 "dlls/vbscript/parser.tab.c"
    break;

  case 141: /* LiteralExpression: tString  */
#line 411 "dlls/vbscript/parser.y"
                                    { (yyval.expression) = new_string_expression(ctx, (yyvsp[0].string)); CHECK_ERROR; }
#line 2800 "dlls/vbscript/parser.tab.c"
    break;

  case 142: /* LiteralExpression: NumericLiteralExpression  */
#line 412 "dlls/vbscript/parser.y"
                                    { (yyval.expression) = (yyvsp[0].expression); }
#line 2806 "dlls/vbscript/parser.tab.c"
    break;

  case 143: /* LiteralExpression: tEMPTY  */
#line 413 "dlls/vbscript/parser.y"
                                    { (yyval.expression) = new_expression(ctx, EXPR_EMPTY, 0); CHECK_ERROR; }
#line 2812 "dlls/vbscript/parser.tab.c"
    break;

  case 144: /* LiteralExpression: tNULL  */
#line 414 "dlls/vbscript/parser.y"
                                    { (yyval.expression) = new_expression(ctx, EXPR_NULL, 0); CHECK_ERROR; }
#line 2818 "dlls/vbscript/parser.tab.c"
    break;

  case 145: /* LiteralExpression: tNOTHING  */
#line 415 "dlls/vbscript/parser.y"
                                    { (yyval.expression) = new_expression(ctx, EXPR_NOTHING, 0); CHECK_ERROR; }
#line 2824 "dlls/vbscript/parser.tab.c"
    break;

  case 146: /* NumericLiteralExpression: '0'  */
#line 418 "dlls/vbscript/parser.y"
                                    { (yyval.expression) = new_long_expression(ctx, EXPR_INT, 0); CHECK_ERROR; }
#line 2830 "dlls/vbscript/parser.tab.c"
    break;

  case 147: /* NumericLiteralExpression: tInt  */
#line 419 "dlls/vbscript/parser.y"
                                    { (yyval.expression) = new_long_expression(ctx, EXPR_INT, (yyvsp[0].integer)); CHECK_ERROR; }
#line 2836 "dlls/vbscript/parser.tab.c"
    break;

  case 148: /* NumericLiteralExpression: tDouble  */
#line 420 "dlls/vbscript/parser.y"
                                    { (yyval.expression) = new_double_expression(ctx, (yyvsp[0].dbl)); CHECK_ERROR; }
#line 2842 "dlls/vbscript/parser.tab.c"
    break;

  case 149: /* IntegerValue: '0'  */
#line 423 "dlls/vbscript/parser.y"
                                    { (yyval.uint) = 0; }
#line 2848 "dlls/vbscript/parser.tab.c"
    break;

  case 150: /* IntegerValue: tInt  */
#line 424 "dlls/vbscript/parser.y"
                                    { (yyval.uint) = (yyvsp[0].integer); }
#line 2854 "dlls/vbscript/parser.tab.c"
    break;

  case 151: /* PrimaryExpression: tEXPRLBRACKET Expression ')'  */
#line 427 "dlls/vbscript/parser.y"
                                              { (yyval.expression) = new_unary_expression(ctx, EXPR_BRACKETS, (yyvsp[-1].expression)); }
#line 2860 "dlls/vbscript/parser.tab.c"
    break;

  case 152: /* PrimaryExpression: tME  */
#line 428 "dlls/vbscript/parser.y"
                                    { (yyval.expression) = new_expression(ctx, EXPR_ME, 0); CHECK_ERROR; }
#line 2866 "dlls/vbscript/parser.tab.c"
    break;

  case 153: /* ClassDeclaration: tCLASS Identifier StSep ClassBody tEND tCLASS StSep  */
#line 431 "dlls/vbscript/parser.y"
                                                                { (yyvsp[-3].class_decl)->name = (yyvsp[-5].string); (yyval.class_decl) = (yyvsp[-3].class_decl); }
#line 2872 "dlls/vbscript/parser.tab.c"
    break;

  case 154: /* ClassBody: %empty  */
#line 434 "dlls/vbscript/parser.y"
                                                  { (yyval.class_decl) = new_class_decl(ctx); }
#line 2878 "dlls/vbscript/parser.tab.c"
    break;

  case 155: /* ClassBody: FunctionDecl  */
#line 435 "dlls/vbscript/parser.y"
                                                  { (yyval.class_decl) = add_class_function(ctx, new_class_decl(ctx), (yyvsp[0].func_decl)); CHECK_ERROR; }
#line 2884 "dlls/vbscript/parser.tab.c"
    break;

  case 156: /* ClassBody: FunctionDecl StSep ClassBody  */
#line 436 "dlls/vbscript/parser.y"
                                                  { (yyval.class_decl) = add_class_function(ctx, (yyvsp[0].class_decl), (yyvsp[-2].func_decl)); CHECK_ERROR; }
#line 2890 "dlls/vbscript/parser.tab.c"
    break;

  case 157: /* ClassBody: Storage tIdentifier  */
#line 438 "dlls/vbscript/parser.y"
                                                  { dim_decl_t *dim_decl = new_dim_decl(ctx, (yyvsp[0].string), FALSE, NULL); CHECK_ERROR;
                                                  (yyval.class_decl) = add_dim_prop(ctx, new_class_decl(ctx), dim_decl, (yyvsp[-1].uint)); CHECK_ERROR; }
#line 2897 "dlls/vbscript/parser.tab.c"
    break;

  case 158: /* ClassBody: Storage tIdentifier StSep ClassBody  */
#line 440 "dlls/vbscript/parser.y"
                                                  { dim_decl_t *dim_decl = new_dim_decl(ctx, (yyvsp[-2].string), FALSE, NULL); CHECK_ERROR;
                                                  (yyval.class_decl) = add_dim_prop(ctx, (yyvsp[0].class_decl), dim_decl, (yyvsp[-3].uint)); CHECK_ERROR; }
#line 2904 "dlls/vbscript/parser.tab.c"
    break;

  case 159: /* ClassBody: tDIM DimDecl  */
#line 442 "dlls/vbscript/parser.y"
                                                  { (yyval.class_decl) = add_dim_prop(ctx, new_class_decl(ctx), (yyvsp[0].dim_decl), 0); CHECK_ERROR; }
#line 2910 "dlls/vbscript/parser.tab.c"
    break;

  case 160: /* ClassBody: tDIM DimDecl StSep ClassBody  */
#line 443 "dlls/vbscript/parser.y"
                                                  { (yyval.class_decl) = add_dim_prop(ctx, (yyvsp[0].class_decl), (yyvsp[-2].dim_decl), 0); CHECK_ERROR; }
#line 2916 "dlls/vbscript/parser.tab.c"
    break;

  case 161: /* ClassBody: PropertyDecl  */
#line 444 "dlls/vbscript/parser.y"
                                                  { (yyval.class_decl) = add_class_function(ctx, new_class_decl(ctx), (yyvsp[0].func_decl)); CHECK_ERROR; }
#line 2922 "dlls/vbscript/parser.tab.c"
    break;

  case 162: /* ClassBody: PropertyDecl StSep ClassBody  */
#line 445 "dlls/vbscript/parser.y"
                                                  { (yyval.class_decl) = add_class_function(ctx, (yyvsp[0].class_decl), (yyvsp[-2].func_decl)); CHECK_ERROR; }
#line 2928 "dlls/vbscript/parser.tab.c"
    break;

  case 163: /* PropertyDecl: Storage_opt tPROPERTY tGET tIdentifier ArgumentsDecl_opt StSep BodyStatements tEND tPROPERTY  */
#line 449 "dlls/vbscript/parser.y"
                                    { (yyval.func_decl) = new_function_decl(ctx, (yyvsp[-5].string), FUNC_PROPGET, (yyvsp[-8].uint), (yyvsp[-4].arg_decl), (yyvsp[-2].statement)); CHECK_ERROR; }
#line 2934 "dlls/vbscript/parser.tab.c"
    break;

  case 164: /* PropertyDecl: Storage_opt tPROPERTY tLET tIdentifier '(' ArgumentDecl ')' StSep BodyStatements tEND tPROPERTY  */
#line 451 "dlls/vbscript/parser.y"
                                    { (yyval.func_decl) = new_function_decl(ctx, (yyvsp[-7].string), FUNC_PROPLET, (yyvsp[-10].uint), (yyvsp[-5].arg_decl), (yyvsp[-2].statement)); CHECK_ERROR; }
#line 2940 "dlls/vbscript/parser.tab.c"
    break;

  case 165: /* PropertyDecl: Storage_opt tPROPERTY tSET tIdentifier '(' ArgumentDecl ')' StSep BodyStatements tEND tPROPERTY  */
#line 453 "dlls/vbscript/parser.y"
                                    { (yyval.func_decl) = new_function_decl(ctx, (yyvsp[-7].string), FUNC_PROPSET, (yyvsp[-10].uint), (yyvsp[-5].arg_decl), (yyvsp[-2].statement)); CHECK_ERROR; }
#line 2946 "dlls/vbscript/parser.tab.c"
    break;

  case 166: /* FunctionDecl: Storage_opt tSUB Identifier ArgumentsDecl_opt StSep BodyStatements tEND tSUB  */
#line 457 "dlls/vbscript/parser.y"
                                    { (yyval.func_decl) = new_function_decl(ctx, (yyvsp[-5].string), FUNC_SUB, (yyvsp[-7].uint), (yyvsp[-4].arg_decl), (yyvsp[-2].statement)); CHECK_ERROR; }
#line 2952 "dlls/vbscript/parser.tab.c"
    break;

  case 167: /* FunctionDecl: Storage_opt tFUNCTION Identifier ArgumentsDecl_opt StSep BodyStatements tEND tFUNCTION  */
#line 459 "dlls/vbscript/parser.y"
                                    { (yyval.func_decl) = new_function_decl(ctx, (yyvsp[-5].string), FUNC_FUNCTION, (yyvsp[-7].uint), (yyvsp[-4].arg_decl), (yyvsp[-2].statement)); CHECK_ERROR; }
#line 2958 "dlls/vbscript/parser.tab.c"
    break;

  case 168: /* Storage_opt: %empty  */
#line 462 "dlls/vbscript/parser.y"
                                    { (yyval.uint) = 0; }
#line 2964 "dlls/vbscript/parser.tab.c"
    break;

  case 169: /* Storage_opt: Storage  */
#line 463 "dlls/vbscript/parser.y"
                                    { (yyval.uint) = (yyvsp[0].uint); }
#line 2970 "dlls/vbscript/parser.tab.c"
    break;

  case 170: /* Storage: tPUBLIC tDEFAULT  */
#line 466 "dlls/vbscript/parser.y"
                                    { (yyval.uint) = STORAGE_IS_DEFAULT; }
#line 2976 "dlls/vbscript/parser.tab.c"
    break;

  case 171: /* Storage: tPUBLIC  */
#line 467 "dlls/vbscript/parser.y"
                                    { (yyval.uint) = 0; }
#line 2982 "dlls/vbscript/parser.tab.c"
    break;

  case 172: /* Storage: tPRIVATE  */
#line 468 "dlls/vbscript/parser.y"
                                    { (yyval.uint) = STORAGE_IS_PRIVATE; }
#line 2988 "dlls/vbscript/parser.tab.c"
    break;

  case 173: /* ArgumentsDecl_opt: EmptyBrackets_opt  */
#line 471 "dlls/vbscript/parser.y"
                                                { (yyval.arg_decl) = NULL; }
#line 2994 "dlls/vbscript/parser.tab.c"
    break;

  case 174: /* ArgumentsDecl_opt: '(' ArgumentDeclList ')'  */
#line 472 "dlls/vbscript/parser.y"
                                                { (yyval.arg_decl) = (yyvsp[-1].arg_decl); }
#line 3000 "dlls/vbscript/parser.tab.c"
    break;

  case 175: /* ArgumentDeclList: ArgumentDecl  */
#line 475 "dlls/vbscript/parser.y"
                                                { (yyval.arg_decl) = (yyvsp[0].arg_decl); }
#line 3006 "dlls/vbscript/parser.tab.c"
    break;

  case 176: /* ArgumentDeclList: ArgumentDecl ',' ArgumentDeclList  */
#line 476 "dlls/vbscript/parser.y"
                                                { (yyvsp[-2].arg_decl)->next = (yyvsp[0].arg_decl); (yyval.arg_decl) = (yyvsp[-2].arg_decl); }
#line 3012 "dlls/vbscript/parser.tab.c"
    break;

  case 177: /* ArgumentDecl: Identifier EmptyBrackets_opt  */
#line 479 "dlls/vbscript/parser.y"
                                                { (yyval.arg_decl) = new_argument_decl(ctx, (yyvsp[-1].string), TRUE); }
#line 3018 "dlls/vbscript/parser.tab.c"
    break;

  case 178: /* ArgumentDecl: tBYREF Identifier EmptyBrackets_opt  */
#line 480 "dlls/vbscript/parser.y"
                                                { (yyval.arg_decl) = new_argument_decl(ctx, (yyvsp[-1].string), TRUE); }
#line 3024 "dlls/vbscript/parser.tab.c"
    break;

  case 179: /* ArgumentDecl: tBYVAL Identifier EmptyBrackets_opt  */
#line 481 "dlls/vbscript/parser.y"
                                                { (yyval.arg_decl) = new_argument_decl(ctx, (yyvsp[-1].string), FALSE); }
#line 3030 "dlls/vbscript/parser.tab.c"
    break;

  case 180: /* Identifier: tIdentifier  */
#line 485 "dlls/vbscript/parser.y"
                     { (yyval.string) = (yyvsp[0].string); }
#line 3036 "dlls/vbscript/parser.tab.c"
    break;

  case 181: /* Identifier: tDEFAULT  */
#line 486 "dlls/vbscript/parser.y"
                     { (yyval.string) = (yyvsp[0].string); }
#line 3042 "dlls/vbscript/parser.tab.c"
    break;

  case 182: /* Identifier: tERROR  */
#line 487 "dlls/vbscript/parser.y"
                     { (yyval.string) = (yyvsp[0].string); }
#line 3048 "dlls/vbscript/parser.tab.c"
    break;

  case 183: /* Identifier: tEXPLICIT  */
#line 488 "dlls/vbscript/parser.y"
                     { (yyval.string) = (yyvsp[0].string); }
#line 3054 "dlls/vbscript/parser.tab.c"
    break;

  case 184: /* Identifier: tPROPERTY  */
#line 489 "dlls/vbscript/parser.y"
                     { (yyval.string) = (yyvsp[0].string); }
#line 3060 "dlls/vbscript/parser.tab.c"
    break;

  case 185: /* Identifier: tSTEP  */
#line 490 "dlls/vbscript/parser.y"
                     { (yyval.string) = (yyvsp[0].string); }
#line 3066 "dlls/vbscript/parser.tab.c"
    break;


#line 3070 "dlls/vbscript/parser.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (&yylloc, ctx, YY_("syntax error"));
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc, ctx);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp, ctx);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, ctx, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, ctx);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp, ctx);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 499 "dlls/vbscript/parser.y"


static int parser_error(unsigned *loc, parser_ctx_t *ctx, const char *str)
{
    if(ctx->error_loc == -1)
        ctx->error_loc = *loc;
    if(ctx->hres == S_OK) {
        FIXME("%s: %s\n", debugstr_w(ctx->code + *loc), debugstr_a(str));
        ctx->hres = E_FAIL;
    }else {
        WARN("%s: %08x\n", debugstr_w(ctx->code + *loc), ctx->hres);
    }
    return 0;
}

static void source_add_statement(parser_ctx_t *ctx, statement_t *stat)
{
    if(!stat)
        return;

    /* concatenate both linked lists */
    if(ctx->stats) {
        ctx->stats_tail->next = stat;
        ctx->stats_tail = stat;
    }else {
        ctx->stats = ctx->stats_tail = stat;
    }
    /* find new tail */
    while(ctx->stats_tail->next) {
        ctx->stats_tail=ctx->stats_tail->next;
    }
}

static void source_add_class(parser_ctx_t *ctx, class_decl_t *class_decl)
{
    class_decl->next = ctx->class_decls;
    ctx->class_decls = class_decl;
}

static void handle_isexpression_script(parser_ctx_t *ctx, expression_t *expr)
{
    retval_statement_t *stat;

    if(!expr)
        return;

    stat = new_statement(ctx, STAT_RETVAL, sizeof(*stat), 0);
    if(!stat)
        return;

    stat->expr = expr;
    ctx->stats = &stat->stat;
}

static void *new_expression(parser_ctx_t *ctx, expression_type_t type, size_t size)
{
    expression_t *expr;

    expr = parser_alloc(ctx, size ? size : sizeof(*expr));
    if(expr) {
        expr->type = type;
        expr->next = NULL;
    }

    return expr;
}

static expression_t *new_bool_expression(parser_ctx_t *ctx, VARIANT_BOOL value)
{
    bool_expression_t *expr;

    expr = new_expression(ctx, EXPR_BOOL, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->value = value;
    return &expr->expr;
}

static expression_t *new_string_expression(parser_ctx_t *ctx, const WCHAR *value)
{
    string_expression_t *expr;

    expr = new_expression(ctx, EXPR_STRING, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->value = value;
    return &expr->expr;
}

static expression_t *new_long_expression(parser_ctx_t *ctx, expression_type_t type, LONG value)
{
    int_expression_t *expr;

    expr = new_expression(ctx, type, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->value = value;
    return &expr->expr;
}

static expression_t *new_double_expression(parser_ctx_t *ctx, double value)
{
    double_expression_t *expr;

    expr = new_expression(ctx, EXPR_DOUBLE, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->value = value;
    return &expr->expr;
}

static expression_t *new_unary_expression(parser_ctx_t *ctx, expression_type_t type, expression_t *subexpr)
{
    unary_expression_t *expr;

    expr = new_expression(ctx, type, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->subexpr = subexpr;
    return &expr->expr;
}

static expression_t *new_binary_expression(parser_ctx_t *ctx, expression_type_t type, expression_t *left, expression_t *right)
{
    binary_expression_t *expr;

    expr = new_expression(ctx, type, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->left = left;
    expr->right = right;
    return &expr->expr;
}

static member_expression_t *new_member_expression(parser_ctx_t *ctx, expression_t *obj_expr, const WCHAR *identifier)
{
    member_expression_t *expr;

    expr = new_expression(ctx, EXPR_MEMBER, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->obj_expr = obj_expr;
    expr->identifier = identifier;
    return expr;
}

static call_expression_t *new_call_expression(parser_ctx_t *ctx, expression_t *expr, expression_t *arguments)
{
    call_expression_t *call_expr;

    call_expr = new_expression(ctx, EXPR_CALL, sizeof(*call_expr));
    if(!call_expr)
        return NULL;

    call_expr->call_expr = expr;
    call_expr->args = arguments;
    return call_expr;
}

static call_expression_t *make_call_expression(parser_ctx_t *ctx, expression_t *callee_expr, expression_t *arguments)
{
    call_expression_t *call_expr;

    if(callee_expr->type == EXPR_MEMBER)
        return new_call_expression(ctx, callee_expr, arguments);
    if(callee_expr->type != EXPR_CALL) {
        FIXME("Unhandled for expr type %u\n", callee_expr->type);
        ctx->hres = E_FAIL;
        return NULL;
    }
    call_expr = (call_expression_t*)callee_expr;
    if(!call_expr->args) {
        call_expr->args = arguments;
        return call_expr;
    }

    if(call_expr->args->next) {
        FIXME("Invalid syntax: invalid use of parentheses for arguments\n");
        ctx->hres = E_FAIL;
        return NULL;
    }

    call_expr->args = new_unary_expression(ctx, EXPR_BRACKETS, call_expr->args);
    if(!call_expr->args)
        return NULL;
    if(!arguments)
        return call_expr;

    if(arguments->type != EXPR_NOARG) {
        FIXME("Invalid syntax: missing comma\n");
        ctx->hres = E_FAIL;
        return NULL;
    }

    call_expr->args->next = arguments->next;
    return call_expr;
}

static expression_t *new_new_expression(parser_ctx_t *ctx, const WCHAR *identifier)
{
    string_expression_t *expr;

    expr = new_expression(ctx, EXPR_NEW, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->value = identifier;
    return &expr->expr;
}

static void *new_statement(parser_ctx_t *ctx, statement_type_t type, size_t size, unsigned loc)
{
    statement_t *stat;

    stat = parser_alloc(ctx, size ? size : sizeof(*stat));
    if(stat) {
        stat->type = type;
        stat->loc = loc;
        stat->next = NULL;
    }

    return stat;
}

static statement_t *new_call_statement(parser_ctx_t *ctx, unsigned loc, BOOL is_strict, expression_t *expr)
{
    call_expression_t *call_expr = NULL;
    call_statement_t *stat;

    stat = new_statement(ctx, STAT_CALL, sizeof(*stat), loc);
    if(!stat)
        return NULL;

    switch(expr->type) {
    case EXPR_MEMBER:
        call_expr = new_call_expression(ctx, expr, NULL);
        break;
    case EXPR_CALL:
        call_expr = (call_expression_t*)expr;
        break;
    default:
        FIXME("Unsupported expr type %u\n", expr->type);
        ctx->hres = E_NOTIMPL;
    }
    if(!call_expr)
        return NULL;

    stat->expr = call_expr;
    stat->is_strict = is_strict;
    return &stat->stat;
}

static statement_t *new_assign_statement(parser_ctx_t *ctx, unsigned loc, expression_t *left, expression_t *right)
{
    assign_statement_t *stat;

    stat = new_statement(ctx, STAT_ASSIGN, sizeof(*stat), loc);
    if(!stat)
        return NULL;

    stat->left_expr = left;
    stat->value_expr = right;

    return &stat->stat;
}

static statement_t *new_set_statement(parser_ctx_t *ctx, unsigned loc, expression_t *left, expression_t *right)
{
    assign_statement_t *stat;

    stat = new_statement(ctx, STAT_SET, sizeof(*stat), loc);
    if(!stat)
        return NULL;

    stat->left_expr = left;
    stat->value_expr = right;

    return &stat->stat;
}

static dim_decl_t *new_dim_decl(parser_ctx_t *ctx, const WCHAR *name, BOOL is_array, dim_list_t *dims)
{
    dim_decl_t *decl;

    decl = parser_alloc(ctx, sizeof(*decl));
    if(!decl)
        return NULL;

    decl->name = name;
    decl->is_array = is_array;
    decl->dims = dims;
    decl->next = NULL;
    return decl;
}

static dim_list_t *new_dim(parser_ctx_t *ctx, unsigned val, dim_list_t *next)
{
    dim_list_t *ret;

    ret = parser_alloc(ctx, sizeof(*ret));
    if(!ret)
        return NULL;

    ret->val = val;
    ret->next = next;
    return ret;
}

static statement_t *new_dim_statement(parser_ctx_t *ctx, unsigned loc, dim_decl_t *decls)
{
    dim_statement_t *stat;

    stat = new_statement(ctx, STAT_DIM, sizeof(*stat), loc);
    if(!stat)
        return NULL;

    stat->dim_decls = decls;
    return &stat->stat;
}

static statement_t *new_redim_statement(parser_ctx_t *ctx, unsigned loc, const WCHAR *identifier, BOOL preserve, expression_t *dims)
{
    redim_statement_t *stat;

    stat = new_statement(ctx, STAT_REDIM, sizeof(*stat), loc);
    if(!stat)
        return NULL;

    stat->identifier = identifier;
    stat->preserve = preserve;
    stat->dims = dims;
    return &stat->stat;
}

static elseif_decl_t *new_elseif_decl(parser_ctx_t *ctx, unsigned loc, expression_t *expr, statement_t *stat)
{
    elseif_decl_t *decl;

    decl = parser_alloc(ctx, sizeof(*decl));
    if(!decl)
        return NULL;

    decl->expr = expr;
    decl->stat = stat;
    decl->loc = loc;
    decl->next = NULL;
    return decl;
}

static statement_t *new_while_statement(parser_ctx_t *ctx, unsigned loc, statement_type_t type, expression_t *expr, statement_t *body)
{
    while_statement_t *stat;

    stat = new_statement(ctx, type, sizeof(*stat), loc);
    if(!stat)
        return NULL;

    stat->expr = expr;
    stat->body = body;
    return &stat->stat;
}

static statement_t *new_forto_statement(parser_ctx_t *ctx, unsigned loc, const WCHAR *identifier, expression_t *from_expr,
        expression_t *to_expr, expression_t *step_expr, statement_t *body)
{
    forto_statement_t *stat;

    stat = new_statement(ctx, STAT_FORTO, sizeof(*stat), loc);
    if(!stat)
        return NULL;

    stat->identifier = identifier;
    stat->from_expr = from_expr;
    stat->to_expr = to_expr;
    stat->step_expr = step_expr;
    stat->body = body;
    return &stat->stat;
}

static statement_t *new_foreach_statement(parser_ctx_t *ctx, unsigned loc, const WCHAR *identifier, expression_t *group_expr,
        statement_t *body)
{
    foreach_statement_t *stat;

    stat = new_statement(ctx, STAT_FOREACH, sizeof(*stat), loc);
    if(!stat)
        return NULL;

    stat->identifier = identifier;
    stat->group_expr = group_expr;
    stat->body = body;
    return &stat->stat;
}

static statement_t *new_if_statement(parser_ctx_t *ctx, unsigned loc, expression_t *expr, statement_t *if_stat, elseif_decl_t *elseif_decl,
        statement_t *else_stat)
{
    if_statement_t *stat;

    stat = new_statement(ctx, STAT_IF, sizeof(*stat), loc);
    if(!stat)
        return NULL;

    stat->expr = expr;
    stat->if_stat = if_stat;
    stat->elseifs = elseif_decl;
    stat->else_stat = else_stat;
    return &stat->stat;
}

static statement_t *new_select_statement(parser_ctx_t *ctx, unsigned loc, expression_t *expr, case_clausule_t *case_clausules)
{
    select_statement_t *stat;

    stat = new_statement(ctx, STAT_SELECT, sizeof(*stat), loc);
    if(!stat)
        return NULL;

    stat->expr = expr;
    stat->case_clausules = case_clausules;
    return &stat->stat;
}

static statement_t *new_with_statement(parser_ctx_t *ctx, unsigned loc, expression_t *expr, statement_t *body)
{
    with_statement_t *stat;

    stat = new_statement(ctx, STAT_WITH, sizeof(*stat), loc);
    if(!stat)
        return NULL;

    stat->expr = expr;
    stat->body = body;
    return &stat->stat;
}

static case_clausule_t *new_case_clausule(parser_ctx_t *ctx, expression_t *expr, statement_t *stat, case_clausule_t *next)
{
    case_clausule_t *ret;

    ret = parser_alloc(ctx, sizeof(*ret));
    if(!ret)
        return NULL;

    ret->expr = expr;
    ret->stat = stat;
    ret->next = next;
    return ret;
}

static statement_t *new_onerror_statement(parser_ctx_t *ctx, unsigned loc, BOOL resume_next)
{
    onerror_statement_t *stat;

    stat = new_statement(ctx, STAT_ONERROR, sizeof(*stat), loc);
    if(!stat)
        return NULL;

    stat->resume_next = resume_next;
    return &stat->stat;
}

static arg_decl_t *new_argument_decl(parser_ctx_t *ctx, const WCHAR *name, BOOL by_ref)
{
    arg_decl_t *arg_decl;

    arg_decl = parser_alloc(ctx, sizeof(*arg_decl));
    if(!arg_decl)
        return NULL;

    arg_decl->name = name;
    arg_decl->by_ref = by_ref;
    arg_decl->next = NULL;
    return arg_decl;
}

static function_decl_t *new_function_decl(parser_ctx_t *ctx, const WCHAR *name, function_type_t type,
        unsigned storage_flags, arg_decl_t *arg_decl, statement_t *body)
{
    function_decl_t *decl;

    if(storage_flags & STORAGE_IS_DEFAULT) {
        if(type == FUNC_PROPGET) {
            type = FUNC_DEFGET;
        }else {
            FIXME("Invalid default property\n");
            ctx->hres = E_FAIL;
            return NULL;
        }
    }

    decl = parser_alloc(ctx, sizeof(*decl));
    if(!decl)
        return NULL;

    decl->name = name;
    decl->type = type;
    decl->is_public = !(storage_flags & STORAGE_IS_PRIVATE);
    decl->args = arg_decl;
    decl->body = body;
    decl->next = NULL;
    decl->next_prop_func = NULL;
    return decl;
}

static statement_t *new_function_statement(parser_ctx_t *ctx, unsigned loc, function_decl_t *decl)
{
    function_statement_t *stat;

    stat = new_statement(ctx, STAT_FUNC, sizeof(*stat), loc);
    if(!stat)
        return NULL;

    stat->func_decl = decl;
    return &stat->stat;
}

static class_decl_t *new_class_decl(parser_ctx_t *ctx)
{
    class_decl_t *class_decl;

    class_decl = parser_alloc(ctx, sizeof(*class_decl));
    if(!class_decl)
        return NULL;

    class_decl->funcs = NULL;
    class_decl->props = NULL;
    class_decl->next = NULL;
    return class_decl;
}

static class_decl_t *add_class_function(parser_ctx_t *ctx, class_decl_t *class_decl, function_decl_t *decl)
{
    function_decl_t *iter;

    for(iter = class_decl->funcs; iter; iter = iter->next) {
        if(!wcsicmp(iter->name, decl->name)) {
            if(decl->type == FUNC_SUB || decl->type == FUNC_FUNCTION) {
                FIXME("Redefinition of %s::%s\n", debugstr_w(class_decl->name), debugstr_w(decl->name));
                ctx->hres = E_FAIL;
                return NULL;
            }

            while(1) {
                if(iter->type == decl->type) {
                    FIXME("Redefinition of %s::%s\n", debugstr_w(class_decl->name), debugstr_w(decl->name));
                    ctx->hres = E_FAIL;
                    return NULL;
                }
                if(!iter->next_prop_func)
                    break;
                iter = iter->next_prop_func;
            }

            iter->next_prop_func = decl;
            return class_decl;
        }
    }

    decl->next = class_decl->funcs;
    class_decl->funcs = decl;
    return class_decl;
}

static class_decl_t *add_dim_prop(parser_ctx_t *ctx, class_decl_t *class_decl, dim_decl_t *dim_decl, unsigned storage_flags)
{
    if(storage_flags & STORAGE_IS_DEFAULT) {
        FIXME("variant prop van't be default value\n");
        ctx->hres = E_FAIL;
        return NULL;
    }

    dim_decl->is_public = !(storage_flags & STORAGE_IS_PRIVATE);
    dim_decl->next = class_decl->props;
    class_decl->props = dim_decl;
    return class_decl;
}

static const_decl_t *new_const_decl(parser_ctx_t *ctx, const WCHAR *name, expression_t *expr)
{
    const_decl_t *decl;

    decl = parser_alloc(ctx, sizeof(*decl));
    if(!decl)
        return NULL;

    decl->name = name;
    decl->value_expr = expr;
    decl->next = NULL;
    return decl;
}

static statement_t *new_const_statement(parser_ctx_t *ctx, unsigned loc, const_decl_t *decls)
{
    const_statement_t *stat;

    stat = new_statement(ctx, STAT_CONST, sizeof(*stat), loc);
    if(!stat)
        return NULL;

    stat->decls = decls;
    return &stat->stat;
}

static statement_t *link_statements(statement_t *head, statement_t *tail)
{
    statement_t *iter;

    for(iter = head; iter->next; iter = iter->next);
    iter->next = tail;

    return head;
}

void *parser_alloc(parser_ctx_t *ctx, size_t size)
{
    void *ret;

    ret = heap_pool_alloc(&ctx->heap, size);
    if(!ret)
        ctx->hres = E_OUTOFMEMORY;
    return ret;
}

HRESULT parse_script(parser_ctx_t *ctx, const WCHAR *code, const WCHAR *delimiter, DWORD flags)
{
    ctx->code = ctx->ptr = code;
    ctx->end = ctx->code + lstrlenW(ctx->code);

    heap_pool_init(&ctx->heap);

    ctx->hres = S_OK;
    ctx->error_loc = -1;
    ctx->last_token = tNL;
    ctx->last_nl = 0;
    ctx->stats = ctx->stats_tail = NULL;
    ctx->class_decls = NULL;
    ctx->option_explicit = FALSE;
    ctx->is_html = delimiter && !wcsicmp(delimiter, L"</script>");

    if(flags & SCRIPTTEXT_ISEXPRESSION)
        ctx->last_token = tEXPRESSION;

    parser_parse(ctx);

    return ctx->hres;
}

void parser_release(parser_ctx_t *ctx)
{
    heap_pool_free(&ctx->heap);
}
